/* pour mmoire,  faire :
Module de dialogue. Comme monologue, mais
- arrt  chaque tat non nonable
- liste des tats nonables les plus plausibles
- demande d'un nom

Voir apprentissage_dialogue

Autoassociation
- dialogue demandant un sous-code droit de p bits
- gnration en compltant  gauche pr l_code-p bits  zro
- monologue

*/



/*  P'tit Bert,  Codage mmoriel de niveau 0 : 

Version actuelle : 2.0 (novembre 1999)

par Maurice.Clerc@WriteMe.com

Historique et prvisions
------------------------

Version 0

Chaque tat mental est cod en binaire sur N bits, correspondants  l'activation ou non
des nuds d'un graphe  N sommets.Pour gnrer les arcs, on indique des transitions souhaitables,
du type "aprs tat i, avoir l'tat j". A partir du graphe dj gnr, le programme calcule un autre
ensemble d'arcs qui satisfasse  la transition indique, en remettant le moins en cause possible
l'apprentissage antrieur (c.--d. en modifiant le moins d'arcs possibles).

Pour la facilit d'usage, les tats ont des "noms", mais la structuration de l'espace des tats mentaux 
est en fait indpendante du choix de ces noms.

Plus prcisment, chaque tat peut tre envoy en entre d'un "nonceur" : celui-ci donne le nom de
l'tat nonable "le plus proche" au sens d'une distance ou quasi-distance entre codes.

Dans cette version :
- la rigidit, c'est--dire la plus ou moins grande facilit de modification d'une valeur
d'arc pour une transition, est la mme partout.
- une modification ne coute rien en terme d'nergie

Il est possible de modifier un code.
On dfinit d'abord la "signification" d'un tat comme tant les ensembles d'ascendants et descendants 
pour chaque niveau d'nergie. Pour modifier le code d'un tat sans changer sa signification, il faut
donc modifier aussi la matrice des transitions. 
Dans l'esprit du modle, ceci se fait de manire incrmentale et non totalement garantie :
la modification d'un code peut parfois imposer de modifier un peu la quasi-mtrique de l'espace cognitif, 
(comprise comme l'ensemble des distances entre tats nonables).

Version 1.0 (rigidits locales)

-  la rigidit est optionnellement diffrente pour chaque ligne de la matrice, typiquement de plus en plus
grande avec le numro de ligne. Par consquent, les dernires lignes de la matrice sont alors difficilement
modifiables.
De cette manire, un tat dont les bits  1 sont dans les derniers transite toujours vers le mme tat suivant,
quelles que soient les modifications affectant par ailleurs la matrice. On ralise ainsi une mmoire stable.

Version 1.1 (stabilisation/consolidation de l'apprentissage)

- On peut alors rendre stable une transition en modifiant le code de l'tat d'origine, de manire  "concentrer"
les bits  1 dans les derniers. 


Version 2 (couplage code/signification)

- les codes deviennent "significatifs". C'est--dire que si une transition de A  B est facile, on s'arrange pour
que leurs codes se ressemblent, quitte  les modifier.
La quasi-mtrique nous donne la "distance de transition" (nergtique) de A vers B.
 On cherche  rapprocher de celle-ci la distance entre codes qui a t choisie (par ex. la psychovalide). 

Plus il y aura bonne concordance entre distance de codes et distance de transition, moins une ventuelle modification du code 
(en particulier pour la consolidation) risquera de remettre en cause des apprentissages n'ayant rien  voir avec celui
considr. Et plus galement l'autoassociation sera facile et fiable.

- tout apprentissage a un cout nergtique

- auto-association (prsentation d'un sous-code et rponse en retour des tats les plus proches)

*/

#include <math.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define fin '\0' /* Fin de chaine de caractres */
#define l_nom 60 /* Longueur max en nb de caractres des noms utiliss */
#define l_code 20 /* Longueur du code binaire des tats */
#define l_ligne 41  /* l_nom + 1 + l_code */
#define l_recomm 44 /* 2*l_nom + 4 */

#define nbits_1 4   /* Nb max de bits  1 dans la cration du code d'un tat 
					Il faut essayer de minimiser la proba d'avoir deux codes identiques par hasard
					ce qui impliquerait l_code/2, mais il faut aussi garder la possibilit
					de "tasser" les codes sur la droite (stabilisation). C'est pourquoi
					on prconise moins de l_code/4 */
#define nbits_0 18  /* Nb max de bits  0. Note : il faut n_bits_0 + n_bits_1 >= l_code */	
#define nmax_etats 50 /* Nb maximum d'tats possibles */
#define nmax_recomms 20 /* Nb maximum de recommandations possibles en apprentissage par lots 
							ATTENTION : plantage grave dans genere_recomms si valeur trop grande (ex. : 100 )*/

#define sep '/'


FILE *f_trace;
struct chaine 			{char c[10];};
struct code 			{int code[l_code];};
struct etat 			{char nom[l_nom];struct code code;};
struct liste_chaines	{struct chaine c[2*l_code];};
struct liste_etats		{int n_etats; struct etat l[nmax_etats+1];};
struct matrice 			{int taille;float M[l_code][l_code];};
struct metrique			{int taille;float infini;float D[nmax_etats][nmax_etats];};
struct recomm 			{char nom1[l_nom];char nom2[l_nom];int avis;};
struct recomm_e 		{struct etat a;struct etat b;int avis;};
struct liste_recomms	{int n_recomms;struct recomm r[nmax_recomms];};
struct liste_recomms_e	{int n_recomms;struct recomm_e r[nmax_recomms];};
struct question 		{char nom[l_nom];};
struct liste_questions 	{int n_questions;struct question q[nmax_etats];};

/*
struct nom_noeud {char n[l_nom];};
struct liste_noms_noeuds	{struct nom_noeud n[nmax_etats];};			
*/			
				
/* Sous-programmes  (dclarations) */
void					affiche(struct etat a);
void					affiche_code(struct code c);
void					affiche_distance_cognitive();
void 					affiche_etat(struct etat a);
void					affiche_etats(struct liste_etats l);
void					affiche_metrique(struct metrique D);
void					affiche_recomms(struct liste_recomms r);
void					affiche_trans(struct matrice M);
void					affiche_trans_etats_graph(struct liste_etats l,struct matrice M);
int						alea(int min,int max);
void 					apprend_liste(char nom_fichier[l_nom],FILE *fichier,struct liste_etats *l,struct matrice *M,int type_rigid);
void 					apprentissage_dialogue(struct liste_etats l,struct matrice M,int rang,float seuil,int logique);
struct matrice 			auto_trans(struct liste_etats l,struct matrice M);
int						avis_d(float distance); /* Calcule une valeur d'avis en fonction de la distance entre deux codes */
void					cauchemar(struct liste_etats l,struct matrice M);
int 					cherche_nom_etat(char nom_etat[l_nom],struct liste_etats l); /* Renvoie le rang de l'tat, -1 sinon */
float					coeff_recomm(int recomm);
float					coeff_rigidite(int rigidite);
void 					coherence(struct liste_etats l0,struct matrice M0,struct liste_etats *l,struct matrice *M);
int						compare_codes(struct code code1,struct code code2); /* Renvoie 1 si gaux */
int						compare_noms(char nom1[l_code],char nom2[l_code]); /* Renvoie 1 si gaux */
float 					confiance_nom(float d,int long_code); /* Calcul un niveau de confiance en fonction d'une distance */
struct code				copie_code(char code[l_code]);
void					couplage_code_signif();
struct code				cree_code();
struct liste_etats		cree_etat(char nom_etat[l_nom],struct liste_etats l0);/* Ajoute un tat dont on donne le nom */
int						demande_rigid(int type_rigid); 
float 					distance(struct code a,struct code b,int type_dist);
float 					distance_min(struct code c, struct liste_etats l,int *rang,int type_dist);
						/* Renvoie la distance  l'tat nonable de code le plus proche de c et donne son rang */
int						doublon_code(struct code,struct liste_etats l); /*  Renvoie le rang du doublon, <0 sinon */
void					enonce_code(struct code c,struct liste_etats l);
void					enonce_etat(struct etat a,struct liste_etats l);
void					ecriture_etats(FILE *file,struct liste_etats l);
void					ecriture_metrique(FILE *file,struct metrique D);
void					ecriture_trans(FILE *file,struct matrice M);
struct liste_etats		efface_etats();
float					energ_max(struct matrice M); /* Energie max au-del de laquelle on n'active plus
														de nouvelles transitions */
struct liste_recomms_e 	genere_recomms(int rang,struct code code,struct liste_etats l,struct matrice M,int global);
void					GRAPHES(struct liste_etats l,struct matrice M); /* Raffiche ventuellement les graphiques */ 
struct chaine 			itoa(int number); /* Conversion entier => chaine de caractres */
struct matrice			initialise_trans(struct liste_etats l);
struct liste_etats 		lecture_etats(FILE *file);
struct metrique			lecture_metrique(FILE *file);
struct 	liste_questions lecture_questions(FILE *file);
struct 	liste_recomms 	lecture_recomms(FILE *file);
struct matrice			lecture_trans(FILE *file);
int						long_chaine(char chaine[l_ligne]); /* Remplace strlen */
float					MAX(float a,float b);
int						max_memo(int long_code,int nb_bits_1,int nb_max_etats,float seuil_proba);
int						max_trans_ligne(struct matrice M,int ligne);/* Rang dans la ligne du plus grand lment non nul.
																-1 si tous les lments sont nuls */
struct metrique 		metrique_trans(struct liste_etats l,struct matrice M); 
float					MIN(float a,float b);
void 					modif_code(int rang,struct code code1,struct liste_etats *l,struct matrice *M,int rigidite,int type_rigid,int global,int logique,int *OK);
struct liste_etats 		modif_etat(struct liste_etats l); /* Modification interactive d'un nom d'tat */
struct matrice			modif_trans(struct matrice M,struct etat a,struct etat b,int avis,int rigidite,int type_rigid,int *OK);
void 					monologue(struct liste_etats l,struct matrice M,int rang,int n_trans,float seuil,int logique);
struct liste_etats		noms_codes(FILE *file,struct liste_etats l); /* Ajoute des tats  partir d'une liste de noms */
void					noms_bit(); /* Juste pour la visualisation. Donne des noms aux bits des codes initial et final */
void 					questions (char nom_fichier[l_nom],FILE *file,struct liste_etats l,struct matrice M); /* Rpond  une liste de questions */
float 					resistance(float conductance); /* Fonction inverse d'un lment quelconque de la matrice de transition */
void					reve(struct liste_etats l,struct matrice M);
int						rigid(int ligne,int rigid_max,int type); /* Fonction donnant une rigidit croissante de 0  rigid_max */
void					stabilisation(int rang, struct liste_etats *l,struct matrice *M,int rigidite,int type_rigid,int global);/* Stabilise des transitions */
struct liste_etats 		supprime_etat(struct liste_etats l);
void					toutes_transitions(struct liste_etats l, struct matrice M); /* Monologue en parcourant tous les tats nonables */
struct code				transition(struct code code1,struct matrice M,float seuil,int logique); /* Assure la transition d'un tat  un autre */
void					transitions_energ(struct liste_etats l, struct matrice M); 
struct matrice 			traite_recomms_e(struct liste_recomms_e r_e,struct matrice M,int n_traite,int rigidite,int type_rigid,int *OK);

/* en cours */
int						verif_code(struct code,struct liste_etats l); /*  <0 => pas code nul _et_ pas doublon */

void					ZZZ(); /* Rserve de code source */



/* Variables globales */

struct code				code_courant;
int 					couleur_noeud[nmax_etats];
/*int						couleur_progressive[5]={White, LightGrey, Grey, DarkGrey, Black };*/
struct	metrique		D;
int 					etat_courant; /* Rang de l'tat courant */
float					flux_energ;
int						inhib_metr; /* 1 => inhibe le calcul de la quasi-mtrique (pour acclrer les tests) */
struct 	liste_etats		l; /* Liste des tats */
int						logique; /* Niveau de logique du raisonnement [0,10] */
struct 	matrice			M; /* Matrice de transition */
int						max_etats; /* Nb max d'tats qu'il est raisonnable de mmoriser */
float					max_trans=9; /* Valeur max dans la matrice de transition */
int						metrique; /* 1 : le calcul de la mtrique a t fait. 0 sinon */
int						n_etats; /* Nombre d'tats nonables */
struct liste_chaines	nom_bit; /* Juste pour la visualisation du graphe de transition */
int						nouv_etat; /* Indicateur de modif de la liste des tats, si >0 */
int						nouv_trans; /* Indicateur de modif de la matrice de transitions, si >0 */
float 					pos_x[l_code];
float 					pos_y[l_code];
float					seuil; /* seuil d'nergie pour activer un nud */
float					seuil_proba; /* Proba maximale acceptable de gnrer au hasard un code doublon */ 
float 					stock_energ;
int						type_modif_trans; /* Voir module modif_trans */
float					v[nmax_etats][nmax_etats];	
int						type_dist; /* Type de distance entre codes. 
							1 = "nergtique", 2 = ensembliste, 3 = angulaire , 4 = psycho-valide, sinon Hamming */ 

/* Visualisations. Cf. aussi ZZZ() */
/**
  	Graph(Out 1); /* Graphe des transitions principales entre tats */
	Directed(1);/* Graphe orient */
	
	Node(Out N,1) For N:InRange(N,0,l.n_etats-1); /* Gnre les ID des nuds, comme numros squentiels */
	NodeColor(N,Out LightGrey,1)   If N!=etat_courant; /* Couleur des nuds inactifs */
	NodeColor(N,Out Red,1)  If N==etat_courant; /* Couleur du nud activ */
	NodeFrame(N,Out C,Out T,1) Assign C=couleur_noeud[N] Assign T=2; /* Mise en valeur des nuds auto-activs */
	NodeLabel(N,Out String,Out S,1) Assign S=l.l[N].nom; /* Met son nom sous chaque nud */
	
	Arc(X,Y,1) If v[X][Y]!=0; 
	ArcThickness(X,Y,Out S,1) Assign S=3*v[X][Y]; /* Epaisseur des arcs en fonction de leur valeur */
									
	/* ArcLabel(X,Y,Out Int,Out L,1) Assign L=v[X][Y];	*/
**/

/**
  	Graph(Out 5); /* Graphe de la matrice de transition */
	Directed(5);/* Graphe orient */
	
	Node(Out N,5) For N:InRange(N,0,l_code-1); /* Gnre les ID des nuds, comme numros squentiels */
	NodeColor(N,Out Red,5)  If code_courant.code[N]==1; /* Couleur du nud activ */
	
	NodeFrame(N,Out C,Out T,5)   Assign T=
	(5*M.M[N][N]/max_trans<1 ? 1 : 5*M.M[N][N]/max_trans)
	Assign C=
	(M.M[N][N]<max_trans/7) ? Black :
(M.M[N][N]<2*max_trans/7) ? DarkBrown :
(M.M[N][N]<3*max_trans/7) ? Brown :
(M.M[N][N]<4*max_trans/7) ? DarkRed :
(M.M[N][N]<5*max_trans/7) ? Red :
(M.M[N][N]<6*max_trans/7) ? Orange :
Yellow
If M.M[N][N]>0 ;
	/* Pour les nuds auto-activs */
	
	NodePos(N,Out X,Out Y,5) Assign X=10*l_code Y=10+20*N  ;
	
	
	Arc(X,Y,5) If M.M[X][Y]>0 ;
	
	 /* Epaisseur des arcs en fonction de leur valeur */

	
	ArcThickness(X,Y,Out S,5) Assign S=
	(5*M.M[X][Y]/max_trans<1 ? 1 : 5*M.M[X][Y]/max_trans)
	If M.M[X][Y]>0 ;
	
	/*ArcColor(X,Y,Out C,5) Assign C=1+15*M.M[X][Y]/max_trans;*/ /* Couleur des arcs en fonction de leur valeur */
	ArcOffset(X,Y,Out K,5) Assign K= ((X-Y)%2==0) ? (-10)*(X-Y) : 10*(X-Y); /* "Arrondi" des arcs */
	
	ArcColor(I,J,Out C,5) Assign C=
	(M.M[I][J]<max_trans/7) ? Black :
(M.M[I][J]<2*max_trans/7) ? DarkBrown :
(M.M[I][J]<3*max_trans/7) ? Brown :
(M.M[I][J]<4*max_trans/7) ? DarkRed :
(M.M[I][J]<5*max_trans/7) ? Red :
(M.M[I][J]<6*max_trans/7) ? Orange :
Yellow
;
	
**/

/**   /* Matrice de transition, prsentation matricielle */
	View(Out -1); 
	MatrixTitle(Out S,-1)    Assign S="Matrice de transition (conductances)";
    Matrix(Out 40,Out 40,Out l_code,Out l_code,-1);
  	/*MatrixItemBackColor(I,J,Out C,-1)  Assign C=9*M.M[I][J]/max_trans;*/
MatrixItemBackColor(I,J,Out C,-1)  Assign C=
(M.M[I][J]<max_trans/7) ? Black :
(M.M[I][J]<2*max_trans/7) ? DarkBrown :
(M.M[I][J]<3*max_trans/7) ? Brown :
(M.M[I][J]<4*max_trans/7) ? DarkRed :
(M.M[I][J]<5*max_trans/7) ? Red :
(M.M[I][J]<6*max_trans/7) ? Orange :
Yellow
;

    MatrixItem(I,J,Out Int,Out L,-1)           Assign L=M.M[I][J];
    /*MatrixItemColor(I,J,Out Red,-1);*/
  
   /* MatrixItemFace(I,J,Out Bold,-1) ;*/
   
**/
	


/* ------------- affichage du code d'tat courant ---------------- */
/**
  	Graph(Out 2); /* Graphe de "l'tat d'esprit" durant un monologue */
	
	Node(Out K,2) For K:InRange(K,0,l_code); /* Gnre les ID des nuds, comme numros squentiels */
	NodeShape(K,Out Square,2) If K<l_code;
	NodeColor(K,Out C,2) Assign C= (code_courant.code[K]==1) ? Red : Grey  If K<l_code;
	
	NodePos(K,Out X,Out Y,2) Assign X=pos_x[K] Y=pos_y[K] If K<l_code;
	NodeLabel(K,Out String,Out S,2) Assign S="" If K<l_code;
	
	/* Titre */
	
	
	NodeColor(K,Out White,2) If K=l_code;
	NodePos(K,Out X,Out Y,2) Assign X=50 Y=0 If K=l_code;
	NodeLabel(K,Out String,Out S,2) Assign S="Cogito ergo sum" If K=l_code;
	NodeName (K,Out String,Out S,2) Assign S="" If K=l_code;
	

**/

/**
  	Graph(Out 3); /* Graphe de la quasi-mtrique partielle (entre tats nonables) */
	Directed(3);/* Graphe orient */
	
	Node(Out N,3) For N:InRange(N,0,D.taille-1); /* Gnre les ID des nuds, comme numros squentiels */
	NodeColor(N,Out Red,3)  If N==etat_courant; /* Couleur du nud activ */
	NodeFrame(N,Out C,Out T,3) Assign C=1+19*D.D[N][N]/D.infini  Assign T=3*(1-D.D[N][N]/D.infini) If D.D[N][N]>0; /* Mise en valeur des nuds auto-activs */
	NodeLabel(N,Out String,Out S,3) Assign S=l.l[N].nom; /* Met son nom sous chaque nud */
	
	Arc(X,Y,3);
	ArcThickness(X,Y,Out S,3) Assign S=3*(1-D.D[X][Y]/D.infini); /* Epaisseur des arcs en fonction de leur valeur */
	ArcColor(X,Y,Out C,3) Assign C=1+19*D.D[X][Y]/D.infini; /* Couleur des arcs en fonction de leur valeur */
	ArcOffset(X,Y,Out K,3) Assign K=10; /* "Arrondi" des arcs */



**/


void main()  /*  */
{
FILE *f_etats; /* liste "nom/code" des tats */
FILE *f_metrique; /* Matrice de quasi-mtrique */
FILE *f_noms_etats; /* Liste "nom" des tats, pour apprentissage */
FILE *f_questions; /* Liste de questions (tats initiaux) */
FILE *f_recomms; /* Liste de recommandations */
FILE *f_trans; /* Matrice des transitions */




struct etat			a;
int					avis;
struct etat 		b;
char 				code[l_code];
struct code			code1;
struct code 		code2;
char				fichier_etats[l_nom];
char				fichier_metrique[l_nom];
char				fichier_noms_etats[l_nom];
char				fichier_questions[l_nom];
char				fichier_recomms[l_nom];
char				fichier_trans[l_nom];
int					global;
int 				long_code;
int 				n_trans; /* Nombre de transitions de monologue */
char 				nom[l_nom];
int 				OK;
int					rang;
int 				rang1; /* Rang d'un tat dans la liste */
char				repertoire[20]; /* Nom du rpertoire de travail */
char				reponse[1];
int					rigidite; /* entre 0 et 100. Il est important de noter qu'une rigidit nulle implique
							un apprentissage apparement parfait et immdiat ... mais aussi un oubli tout 
							parfait et immdiat de connaissances antrieures.  */
 
int					type_rigid; /* Type de variation de rigidit. 0 = constante, 1 = linaire */
									

noms_bit(); /* Pour la visualisation, affecte des noms aux bits du code initial et du code final */

								
etat_courant=nmax_etats;
code_courant=l.l[etat_courant].code;

flux_energ=10;
logique=10; /* Logique de 0 (nulle)  10 (parfaite) */
long_code=l_code;
max_trans=9; /* Valeur max dans la matrice de transition (voir aussi le module "resistance") */
metrique=0;
nouv_etat=0; /* Indicateur de modification de la liste des tats */
nouv_trans=0; /* Indicateur de modification de la matrice de transitions */

seuil=2; /* On indique le niveau d'activation sur un bit de code pour qu'il passe  1 
			typiquement l_code/10 */
seuil_proba=0.5; /* Si la proba de crer par hasard un code doublon est suprieure  ce seuil
				message d'alerte */
stock_energ=0; /* Dmarrage avec un stock d'nergie donn */

type_dist=4; /* Cf module "distance" */


type_modif_trans=1; /* Voir module modif_trans */

type_rigid=0; /* 0 = rigidit constante, 1 = rigidit variable */
if (type_rigid==0) rigidite=50; else rigidite=100; /* On dfinit par dfaut une rigidit moyenne */



/*----------------------------------------------------------------- */

printf("\n Rpertoire de travail (dfaut = courant) ? ");

	gets(repertoire);
	switch(repertoire[0])
		{
		
		case 0:/*case '\n':*/
		strcpy (repertoire,"courant");
		break;
		
		default: 
		break;
		}
		

printf("\nOuverture des fichiers du rpertoire %s",repertoire); 
strcpy(fichier_questions,"/memoires/");
strcat (fichier_questions,repertoire);
strcat (fichier_questions,"/questions.TXT");
f_questions=fopen(fichier_questions,"r");

if (!f_questions) 
	printf("\nERREUR: Impossible d'ouvrir "
               "le fichier: %s\n", fichier_questions);

strcpy(fichier_recomms,"/memoires/");
strcat (fichier_recomms,repertoire);
strcat (fichier_recomms,"/recomms.TXT");
f_recomms=fopen(fichier_recomms,"r");
if (!f_recomms) 
	printf("\nERREUR: Impossible d'ouvrir "
               "le fichier: %s\n", fichier_recomms);

strcpy(fichier_etats,"/memoires/");
strcat (fichier_etats,repertoire);
strcat (fichier_etats,"/etats.TXT");
f_etats=fopen(fichier_etats,"r");
if (!f_etats) 
	printf("\nERREUR: Impossible d'ouvrir "
               "le fichier: %s\n", fichier_etats);

strcpy(fichier_metrique,"/memoires/");
strcat (fichier_metrique,repertoire);
strcat (fichier_metrique,"/metrique.TXT");
f_metrique=fopen(fichier_metrique,"r");
if (!f_metrique) 
	printf("\nERREUR: Impossible d'ouvrir "
               "le fichier: %s\n", fichier_metrique);

strcpy(fichier_noms_etats,"/memoires/");
strcat (fichier_noms_etats,repertoire);
strcat (fichier_noms_etats,"/noms_etats.TXT");
f_noms_etats=fopen(fichier_noms_etats,"r");
if (!f_noms_etats) 
	printf("\nERREUR: Impossible d'ouvrir "
               "le fichier: %s\n", fichier_noms_etats);

f_trace=fopen("TRACE.TXT","w");

strcpy(fichier_trans,"/memoires/");
strcat (fichier_trans,repertoire);
strcat (fichier_trans,"/trans.TXT");
f_trans=fopen(fichier_trans,"r");
if (!f_trans) 
	printf("\nERREUR: Impossible d'ouvrir "
               "le fichier: %s\n", fichier_trans);


max_etats=max_memo(l_code,nbits_1,nmax_etats,seuil_proba); /* Nb thorique d'tats acceptable */

printf("\n Le nombre raisonnable d'tats que je peux mmoriser est de %i ",max_etats);
printf("\nVoudrez-vous le recalcul systmatique de la quasi-mtrique (assez long) ? (O/o) ?: ");
	scanf("%s",&reponse);

	if (reponse[0]=='O' || reponse[0]=='o') 
		{inhib_metr=0;}
	else {inhib_metr=1;}
		
	 

/* Lecture de la matrice du graphe (transitions) */

 M=lecture_trans(f_trans); 

/* Lecture de la liste des tats nomms */

l=lecture_etats(f_etats);
n_etats=l.n_etats;

/* Lecture de la quasi-mtrique */
D=lecture_metrique(f_metrique);

/* Affichages graphiques */
GRAPHES(l,M);
if (inhib_metr==0) D=metrique_trans(l,M); /* Calcul et affichage de la quasi-mtrique. Assez long */

/*   Choix du mode de fonctionnement */
choix:
printf("\n");
printf("\n0 = Fin normale (avec sauvegarde)");
printf("\n1 = Apprentissage ...");
printf("\n2 = Monologue ...");
printf("\n3 = Maintenance ...");
printf("\n4 = Affichage ...");
printf("\nS = Stop (fin sans sauvegarde)");

printf("\nVotre choix ? :  ");
scanf("%s",&reponse);


if (reponse[0]=='0') goto FIN;
if (reponse[0]=='1') goto menu_apprentissage;
if (reponse[0]=='2') goto menu_monologue;
if (reponse[0]=='3') goto menu_maintenance;
if (reponse[0]=='4') goto menu_affichage;
if (reponse[0]=='S') goto stop;

printf("Ce n'est pas un choix valide !");
goto choix;

menu_apprentissage:
printf("\n");
printf("\n0 = Retour au menu gnral");
printf("\n1 = Apprentissage interactif de transitions");
printf("\n2 = Apprentissage de transitions  partir d'une liste de recommandations (recomms.TXT)");
printf("\n3 = Apprentissage interactif de noms d'tats");
printf("\n4 = Lecture de nouveaux noms depuis un fichier (noms_etats.TXT), et affectation de codes");
printf("\n5 = Stabilisation interactive des transitions issues d'un code donn");
printf("\n6 = Codes signifiants (rorganisation globale)");


printf("\nVotre choix ? :  ");
scanf("%s",&reponse);

if (reponse[0]=='0') goto choix;
if (reponse[0]=='1') goto apprentissage;
if (reponse[0]=='2') 
	{apprend_liste(fichier_recomms,f_recomms,&l,&M,type_rigid);
	goto menu_apprentissage;
	};
if (reponse[0]=='3') 
	{apprentissage_dialogue(l,M,alea(0,l.n_etats-1),seuil,logique);	
	goto menu_apprentissage;
	};
	
if (reponse[0]=='4') 
	{l=noms_codes(f_noms_etats,l);
	GRAPHES(l,M);
	if (inhib_metr==0) D=metrique_trans(l,M);
	goto menu_apprentissage;};
if (reponse[0]=='5') goto stabilisation;
if (reponse[0]=='6') 
	{couplage_code_signif();
	goto menu_apprentissage;};

printf("Ce n'est pas un choix valide !");
goto menu_apprentissage;

menu_monologue:
printf("\n");
printf("\n0 = Retour au menu gnral");
printf("\n1 = Monologue");
printf("\n2 = Rponses  une liste de questions (fichier questions.TXT)");
printf("\n3 = Toutes les transitions");
printf("\n4 = Rve");
printf("\n5 = Cauchemar");
printf("\n6 = Excitation croissante");

printf("\nVotre choix ? :  ");
scanf("%s",&reponse);

if (reponse[0]=='0') goto choix;
if (reponse[0]=='1') goto monologue;
if (reponse[0]=='2') {questions(fichier_questions,f_questions,l,M);goto menu_monologue;};
if (reponse[0]=='3') {toutes_transitions(l,M);goto menu_monologue;};
if (reponse[0]=='4') {reve(l,M);goto menu_monologue;};
if (reponse[0]=='5') {cauchemar(l,M);goto menu_monologue;};
if (reponse[0]=='6') {transitions_energ(l,M);goto menu_monologue;};

printf("Ce n'est pas un choix valide !");
goto menu_monologue;

menu_maintenance:
printf("\n");
printf("\n0 = Retour au menu gnral");
printf("\n1 = Initialise la matrice de transition");
printf("\n2 = Efface les tats nonables");
printf("\n3 = Modification d'un nom d'tat");
printf("\n4 = Suppression d'un tat");
printf("\n5 = Modification d'un code");
printf("\n6 = Cohrence doublons(suppression des doublons de codes)");
printf("\n7 = Cohrence auto-transition (transition facile de chaque tat vers lui-mme");
printf("\n8 = Sauvegarde intermdiaire (tats, matrice de transition, ventuellement mtrique");


printf("\nVotre choix ? :  ");
scanf("%s",&reponse);

if (reponse[0]=='0') goto choix;
if (reponse[0]=='1') 
	{M=initialise_trans(l);
	GRAPHES(l,M);
	goto menu_maintenance;};
if (reponse[0]=='2') 
	{l=efface_etats();
	GRAPHES(l,M);
	if (inhib_metr==0) D=metrique_trans(l,M);
	goto menu_maintenance;};
if (reponse[0]=='3') 
	{l=modif_etat(l);
	GRAPHES(l,M);
	goto menu_maintenance;};
if (reponse[0]=='4') 
	{l=supprime_etat(l);
	GRAPHES(l,M);
	if (inhib_metr==0) D=metrique_trans(l,M);
	goto menu_maintenance;};
if (reponse[0]=='5') goto modif_code;
if (reponse[0]=='6') goto supprime_doublons;
if (reponse[0]=='7') 
	{M=auto_trans(l,M);
	GRAPHES(l,M);
	if (inhib_metr==0) D=metrique_trans(l,M);
	goto menu_maintenance;};
	
if (reponse[0]=='8') 
	{
	if (nouv_etat>0) 
		{	
		fclose(f_etats);f_etats=fopen(fichier_etats,"w");
		ecriture_etats(f_etats,l);
		printf("\n\n Sauvegarde de la liste des tats ");
		fclose(f_etats);f_etats=fopen(fichier_etats,"r");
		
		}
	
	if (nouv_trans>0)
		{
		fclose(f_trans);f_trans=fopen(fichier_trans,"w");
		ecriture_trans(f_trans,M);
		printf("\n Sauvegarde de la matrice de transition ");
		fclose(f_trans);f_trans=fopen(fichier_trans,"r");
		}

	
		fclose(f_metrique);f_metrique=fopen(fichier_metrique,"w");
		ecriture_metrique(f_metrique,D);
		fclose(f_metrique);f_metrique=fopen(fichier_metrique,"r");
		
	goto menu_maintenance;
	}

printf("Ce n'est pas un choix valide !");
goto menu_maintenance;

menu_affichage:
printf("\n");
printf("\n0 = Retour au menu gnral");
printf("\n1 = affiche la matrice de transition en format texte");
printf("\n2 = Liste des tats nonables");
printf("\n3 = Quasi-mtrique de l'espace cognitif, en format texte");
printf("\n4 = Quasi-mtrique de l'espace cognitif, en format graphique");
printf("\n5 = Distance cognitive entre deux tats");

printf("\nVotre choix ? :  ");
scanf("%s",&reponse);

if (reponse[0]=='0') goto choix;
if (reponse[0]=='1'){ affiche_trans(M);goto menu_affichage;};
if (reponse[0]=='2'){ affiche_etats(l);goto menu_affichage;};
if (reponse[0]=='3') {D=metrique_trans(l,M);affiche_metrique(D);goto menu_affichage;};
if (reponse[0]=='4') 
	{
	if (metrique==0) /* Le calcul de la quasi-mtrique n'a jamais t fait */
		{
		D=metrique_trans(l,M);
		}
		goto menu_affichage;
	}
	
if (reponse[0]=='5'){ affiche_distance_cognitive();goto menu_affichage;};	
	
printf("Ce n'est pas un choix valide !");
goto menu_affichage;



/* ========================================================================== APPRENTISSAGE interactif */
apprentissage:
/* Aprs un tat A, le systme "transite" vers un tat B. 
Une recommandation floue indique soit que :
- l'tat souhait est en fait B' (conseil positif)
- l'tat B n'est pas souhaitable (conseil ngatif)

Cas du conseil positif
----------------------
On compare les codes de B et B'. 
Si le bit i (nud i) de B' est actif et pas le bit i de B,
alors on modifie les liens depuis les nuds actifs de A vers le nud i,
 de faon  ce que si l'on reffectue la transition  partir de A, le bit i serait maintenant
 juste activ pour une rigidit nulle (paramtre global).
Si le bit i de B' est inactif et le bit i de B  actif,
alors on modifie les liens depuis les nuds actifs de A vers le nud i,
 de faon  ce que si l'on reffectue la transition  partir de A, le bit i serait maintenant
 juste inactiv pour une rigidit nulle (paramtre global).
*/



/* Choix d'un tat initial */ 
etat_init:

printf("\nEtat initial ?: ");scanf("%s",&nom);

/* Recherche si cet tat existe dj */

rang=cherche_nom_etat(nom,l);
if (rang>=0) goto suite_appr;

	/* L'tat n'est pas nonable. On demande confirmation pour lui donner un nom  */

	printf("\nCe nom n'est pas encore attribu. \nJe le cre ? (O/o ?: ");
	scanf("%s",&reponse);

	if (reponse[0]=='O' || reponse[0]=='o') 
		{
		n_etats=l.n_etats;l=cree_etat(nom,l);rang=l.n_etats-1;
		GRAPHES(l,M);
		} 
		else goto menu_apprentissage;

suite_appr: /* L'tat initial est bien nonable */



/* Effectue une transition */

a=l.l[rang];
affiche_etat(a); /* Affiche pour mmoire l'tat initial */

code1=a.code;
code2=transition(code1,M,seuil,logique);
enonce_code(code2,l); /* nonciation ...plus ou moins certaine */


printf("\nOn modifie ? (O/o ou N/n) : ");scanf("%s",&reponse);
	if (reponse[0]!='O' && reponse[0]!='o') goto encore_appr;

	/* Demande d'un conseil (une meilleure rponse) */
	
	printf("\n\nNom d'tat (souhaitable ou  viter) ? : ");scanf("%s",&nom);
	
	/* Recherche si cet tat existe dj */

	rang=cherche_nom_etat(nom,l);
	if (rang>=0) goto suite_amelior;
	
	/* L'tat n'est pas nonable. On demande confirmation pour lui donner un nom  */

	printf("\nJe ne connaissais pas du tout cette rponse. \nJe la cre ? (O/o ?: ");
	scanf("%s",&reponse);
	if (reponse[0]=='O' || reponse[0]=='o') 
		{n_etats=l.n_etats;l=cree_etat(nom,l);rang=l.n_etats-1;} else 
		{printf("\nOn recommence.");goto encore_appr;};
	
	
	
	suite_amelior:
	
	printf("\n\nCodes de recommandation (de -10  10)\n-----------------------");
	printf("\n -10 =  viter absolument");
	printf("\n  10 =  obtenir imprativement");
	
	
	
	
	printf("\nRecommandation (entre -10 et 10) ? :");scanf("%i",&avis);

	avis=MAX(MIN(10,avis),-10); /* Ne retient que les valeurs possibles */
		
	/* Modification (ventuelle) des transitions */
	
		
	rigidite=demande_rigid(type_rigid);
	
	b=l.l[rang];
	M=modif_trans(M,a,b,avis,rigidite,type_rigid,&OK);
	if (OK==1) printf("\n Modification de la matrice de transition faite");
	
	GRAPHES(l,M);
encore_appr:


printf("\nNouvel apprentissage ?(O/o): ");  /* Boucle ventuelle pour un nouvel apprentissage */
scanf("%s",&reponse);
if (reponse[0]=='O' || reponse[0]=='o') goto apprentissage;


if (inhib_metr==0) D=metrique_trans(l,M);

goto menu_apprentissage;





/* ================================================================================= MODIF_CODE */
modif_code:
/* Choix de l'tat  modifier */ 

printf("\nEtat dont le code est  modifier ?: ");scanf("%s",&nom);

/* Recherche si cet tat existe dj */

rang=cherche_nom_etat(nom,l);
if (rang<0) 
	{
	/* L'tat n'est pas nonable. On abandonne  */
	printf("\nDsol, je ne connait pas cet tat.");
	goto menu_maintenance;
	}
	
 /* L'tat dont le code est  modifier est bien nonable */

a=l.l[rang];

printf("\nLe code actuel est   : ");affiche_code(a.code);
printf("\nLe code souhait est : ");
scanf("%s",code);

/* Teste si ce code n'existe pas dj pour un tat nonable */

code1=copie_code(code);

rang1=doublon_code(code1,l);

if (rang1>=0)
	{
	printf("\n Dsol, ce code est dja attribu  l'tat %s ",l.l[rang1].nom);
	goto menu_maintenance;
	}

printf("\n0 : dformation locale progressive (assez rapide) ");
printf("\n1 : dformation globale brutale  (plus fiable, mais longue)");
printf("\n2 : dformation globale progressive (encore plus fiable, mais trs longue)");
printf("\n Quel type de dformation voulez-vous (0,1,2) ? : ");
scanf("%i",&global);
global=MAX(MIN(2,global),0);

modif_code(rang,code1,&l,&M,0,type_rigid,global,10,&OK);  /* On tente de modifier effectivement le code, d'o
								modif. probable de la matrice de transition. A noter que la rigidit utilise
								est nulle, car il s'agit ici d'une opration de maintenance */

GRAPHES(l,M);
if (inhib_metr==0) D=metrique_trans(l,M);
goto menu_maintenance;


/* ================================================================================= MONOLOGUE */
/*  partir d'un tat nomm initial, le systme effectue un nombre de transitions
indiqu  l'avance. Aprs chaque transition, il tente de nommer (noncer) son tat,
avec plus ou moins de certitude */

monologue:

printf("\nNom de l'tat initial ?: ");scanf("%s",&nom); /* Saisie de l'tat initial, par son nom */


/* Recherche de l'tat initial. On vrifie qu'il existe bien dans la liste des tats nonables  */
rang=cherche_nom_etat(nom,l);

if (rang<0) 
	{printf("\nEtat non trouv "); goto choix;};
	
printf("\nrang trouv %i ",rang);
printf("\nCombien de transitions ?: ");scanf("%i",&n_trans);
printf("\n");


printf("\n\n Niveau de logique ? (0  10) : ");
scanf("%i",&logique);


/* Transitions. On effectue les transitions demandes, en accord avec l'tat initial et
   la matrice de transition */
suite_monologue:
monologue(l,M,rang,n_trans,seuil,logique);


printf("\nEncore ?(O/o): ");  /* Boucle ventuelle pour un nouveau monologue */
scanf("%s",&reponse);
if (reponse[0]=='O' || reponse[0]=='o') 
	{
	rang=etat_courant;
	goto suite_monologue;
	}
	
goto menu_monologue;


/* ================================================================================= STABILISATION */
stabilisation:

printf("\nNom de l'tat dont les transitions sont  stabiliser ?: ");scanf("%s",&nom); 

/* Recherche de l'tat. On vrifie qu'il existe bien dans la liste des tats nonables  */
rang=cherche_nom_etat(nom,l);

if (rang<0) 
	{printf("\nEtat non trouv "); goto menu_apprentissage;};

printf("\n0 : dformation locale (rapide) ");
printf("\n1 : dformation globale (plus fiable, mais longue)");
printf("\n Quel type de dformation voulez-vous (0 ou 1) ? : ");
scanf("%i",&global);

stabilisation(rang,&l,&M,rigidite,type_rigid,global);

GRAPHES(l,M);
if (inhib_metr==0) D=metrique_trans(l,M);
goto menu_apprentissage;

/* ================================================================================= SUPPRIME_DOUBLONS */
supprime_doublons:
/* L'attribution de codes au hasard fait que deux tats peuvent avoir le mme code, ce qui
conduit  des incohrences. 
On recherche ici ces doublons, et on modifie un des deux codes, itrativement tant qu'il en subsiste.
*/
printf("\nVous tes certain(e) ? (Cela peut tre long) (O/o): "); 
scanf("%s",&reponse);
if (reponse[0]!='O' && reponse[0]!='o') goto menu_maintenance;

coherence(l,M,&l,&M);

GRAPHES(l,M);
if (inhib_metr==0) D=metrique_trans(l,M);
goto menu_maintenance;


/* ================================================================================= FIN */
FIN:

/* Sauvegarde de la "mmoire" */
	
	if (nouv_etat>0) 
		{	
		fclose(f_etats);f_etats=fopen(fichier_etats,"w");
		ecriture_etats(f_etats,l);
		printf("\n\n Sauvegarde de la liste des tats ");
		fclose(f_etats);
		}
	
	if (nouv_trans>0)
		{
		fclose(f_trans);f_trans=fopen(fichier_trans,"w");
		ecriture_trans(f_trans,M);
		printf("\n Sauvegarde de la matrice de transition ");
		fclose(f_trans);
		}

	
		fclose(f_metrique);f_metrique=fopen(fichier_metrique,"w");
		ecriture_metrique(f_metrique,D);
		fclose(f_metrique);

stop:

fclose(f_trace);
fclose(f_recomms);
fclose(f_questions);

printf("\nGxis baldaux !");
}
/*================================================================================================*/
/*========================= Sous-programmes  =====================================================*/



/*------------------------------------------------------------------- AFFICHE_CODE */
void affiche_code(struct code c)
{int i;
for (i=0;i<l_code;i++) printf("%i",c.code[i]);
}


/*------------------------------------------------------------------- AFFICHE_DISTANCE_COGNITIVE */
void	affiche_distance_cognitive()
{
float d;
char nom[l_nom];
int rang1,rang2;
char reponse[1];

printf("\nNom de l'tat initial ?: ");scanf("%s",&nom); /* Saisie de l'tat initial, par son nom */

/* Recherche de l'tat initial. On vrifie qu'il existe bien dans la liste des tats nonables  */
rang1=cherche_nom_etat(nom,l);

if (rang1<0) 
	{printf("\nEtat non trouv "); return;}
	

printf("\nNom de l'tat final ?: ");scanf("%s",&nom); 

rang2=cherche_nom_etat(nom,l);

if (rang1<0) 
	{printf("\nEtat non trouv "); return;}

if (metrique!=1)
	{
	printf("\n Attention, la quasi-mtrique n'a pas t calcule.");
	printf("\n Voulez-vous que je le fasse maintenant (c'est assez long) ? (O/o  ou N/n).");
	scanf("%s",&reponse);
	if (reponse[0]=='O' || reponse[0]=='o')
		{
		D=metrique_trans(l,M);
		}
	else
		return;
 
	}

d=D.D[rang1][rang2]/D.infini;

printf("\n Entre les tats");
printf("\n %s",l.l[rang1].nom);
printf("\n %s",l.l[rang2].nom);
printf("\n   la distance est de %f ( distance max. = 1 )",d);

}


/*------------------------------------------------------------------- AFFICHE_ETAT */
void affiche_etat(struct etat a)
{
printf("\n%s/",a.nom);
affiche_code(a.code);

}

/*------------------------------------------------------------------- AFFICHE_ETATS */
void affiche_etats(struct liste_etats l)
{int j;

if (l.n_etats==0) printf("\n Aucun tat nonable");

if (l.n_etats!=0)
	{
		printf("\nListe des %i tats ",l.n_etats);
		for (j=0;j<l.n_etats;j++)
		{
		affiche_etat(l.l[j]);
		}
	}
}

/*------------------------------------------------------------------- AFFICHE_METRIQUE */
void affiche_metrique(struct metrique D)
{int i,j;
printf("\nAffichage de la quasi-mtrique. Infini = %f ",D.infini);
for (i=0;i<D.taille;i++)
	{
	printf("\n");
	for (j=0;j<D.taille;j++)
		printf("%f   ",D.D[i][j]);
	}
}

/*------------------------------------------------------------------- AFFICHE_RECOMMS */
void affiche_recomms(struct liste_recomms r)
{int j;

if (r.n_recomms==0) printf("\n Aucune recommandation");

if (r.n_recomms!=0)
	{
		printf("\nNombre de recommandations : %i. Liste : ",r.n_recomms);
		for (j=0;j<r.n_recomms;j++)
			{
			printf("\n%s => %s  force %i ",r.r[j].nom1,r.r[j].nom2,r.r[j].avis);
			}
	}

}

/*------------------------------------------------------------------- AFFICHE_TRANS */
void affiche_trans(struct matrice M)
{
int i,j;

printf("\ntaille %i",M.taille); 
for (i=0;i<M.taille;i++)
	
	{
	printf("\n");
	for (j=0;j<M.taille;j++)
		{
		printf("%d ",M.M[i][j]);
		}
	}
}

/*------------------------------------------------------------------- AFFICHE_TRANS_ETATS_GRAPH */
void affiche_trans_etats_graph(struct liste_etats l,struct matrice M)
{
struct etat b;
float 		d;
int 		i,j;
int 		num_noeuds;
int 		rang;

num_noeuds=l.n_etats;


/*printf("\n stock %f flux %f  seuil %f logique %i",stock_energ,flux_energ,seuil,logique);*/

/** Not  Inference; **/

for (i=0;i<num_noeuds;i++)
for (j=0;j<num_noeuds;j++)
	v[i][j]=0;

for (i=0;i<num_noeuds;i++)  /* Pour chaque tat nonable ... */
	{
	
	b.code=transition(l.l[i].code,M,seuil,10); /* ... calcule son descendant le plus "logique" 
									... et cherche le rang de l'tat nonable le plus proche
										et calcule le niveau de confiance correspondant */
	d=distance_min(b.code,l,&rang,type_dist);								
	v[i][rang]=confiance_nom(d,l_code); /* Valeur de l'arc  afficher */
	
	}

	for (i=0;i<num_noeuds;i++)
	if (v[i][i]>0)
		{
	 	couleur_noeud[i]=Red;
		}
	 else 
		{
		couleur_noeud[i]=LightGrey;
		}
	
/*	
printf("\n");printf("\n affiche_trans_etats_graph. Matrice des liens principaux entre tats");		
for (i=0;i<num_noeuds;i++)
	{
	printf("\n");
	for (j=0;j<num_noeuds;j++)
		{
		printf("%f ",v[i][j]);
		}
	}
	
*/

/**  Inference; **/		
		
}


		

/*------------------------------------------------------------------- ALEA */
int alea(int min,int max) /* Renvoie un nb entier pseudo-alatoire entre min et max */
{
float r,sup;

sup=32768;
r=rand()/sup;
r=min+r*(max-min);
return r;
}

/*------------------------------------------------------------------- APPREND_LISTE */
void apprend_liste(char nom_fichier[20],FILE *fichier,struct liste_etats *l,struct matrice *M,int type_rigid)
/* La liste est de la forme 
nom_d_etat_initial/nom_d_etat_final/avis
*/
{
struct etat	a,b;
int OK;
int i;

struct liste_etats lt;  /* Pour l'instant, on ne traite que des recommandations portant sur des tats
								dj nonables, ce qui fait que la liste reste en ralit inchange.
								Ultrieurement, on pourra les apprendre "dans la foule "
								(en lecture de texte, par exemple ).
								*/
struct 		liste_recomms r;
int			rang1,rang2;
struct 		recomm recomm;

int rigidite;

fclose(fichier);
fichier=fopen(nom_fichier,"r");

 lt=*l; 

OK=1;
printf("\n\nApprentissage  partir d'une liste de recommandations ");

rigidite=demande_rigid(type_rigid);

r=lecture_recomms(fichier);

for (i=0;i<r.n_recomms;i++) /* Pour chacune des recommandations ... */
	{
	recomm=r.r[i];
	
	
	rang1=cherche_nom_etat(recomm.nom1,lt);
	if (rang1<0)          /*... si le nom1 est correct ... */
		{
		printf("\n%s",recomm.nom1);
		printf("  ATTENTION, nom inconnu ");
		OK=0;
		}
		
	
	rang2=cherche_nom_etat(recomm.nom2,lt);
	if (rang2<0)        /*... si le nom2 est correct ... */
		{
		printf(" => %s",recomm.nom2);
		printf("  ATTENTION, nom inconnu ");
		OK=0;
		}
	
	
	if (recomm.avis<-10 || recomm.avis>10)  /*... et si la valeur d'avis est correcte ...*/
		{
		printf(" (force %i)",recomm.avis);
		printf("  ATTENTION, valeur d'avis incorrecte ");
		OK=0;	
		}
										/* ...cre un tat initial et un tat final... */
	if (OK==0) continue;
		a=lt.l[rang1];
		b=lt.l[rang2];
	
										/* ... et adapte la matrice des transitions */	
		*M=modif_trans(*M,a,b,recomm.avis,rigidite,type_rigid,&OK);
	if (OK==1) 
		{
		printf("\n Modification de la matrice de transition faite");
		GRAPHES(lt,*M);
		if (inhib_metr==0) D=metrique_trans(lt,*M);
		}
	
	}
	
/* *l=lt; */

}

/*------------------------------------------------------------------- APPRENTISSAGE_DIALOGUE */
void apprentissage_dialogue(struct liste_etats l,struct matrice M,int rang,float seuil,int logique)

{
/* Le systme poursuit un monologue, mais en s'arrtant  chaque tat non nonable.
Il affiche alors les tats nonables les plus proches et demande 
 1 - soit de choisir parmi ceux-l
 2 - soit de donner un nom  l'tat courant
 3 - soit d'arrter

Dans le cas 1 il y a modification de la matrice de transition,
dans le cas 2 il y a seulement un ajout  la liste des tats nonables

*/

struct code	code1,code2;
int choix;

int bidon; /* pour mmoire de modif  faire */

choix=0;
while (choix!=0)
	{
	etat_courant=rang;
	code1=l.l[rang].code;

	code2=transition(code1,M,seuil,logique); /* ... calcul du nouveau code ... */
	
	/* Affichage des tats nonables les plus proches */
	
	
	/* Demande du choix */
	
		/* Si nom  donner, demande du nom */
	
		/* Si le nom existe avec un code diffrent ... */
		
		/* ...soit on lui attribue le nouveau code ...  */
		
		/* ... soit on admet que deux codes peuvent avoir le mme nom */
	
	}

}

/*------------------------------------------------------------------- AUTO_TRANS */
struct matrice auto_trans(struct liste_etats l,struct matrice M)
/* Modifie la matrice de transition, de faon  faciliter la transition de tout tat vers lui-mme */
{int i,OK;struct matrice Mt;
printf("\n Cohrence d'auto-transitions");
Mt=M;
for (i=0;i<l.n_etats;i++)
	{
	Mt=modif_trans(Mt,l.l[i],l.l[i],10,0,0,&OK);
	}
	

return Mt;
}

/*------------------------------------------------------------------- AVIS_D */
int avis_d(float distance) /* Calcule un avis (pour recommandation), en fonction de la
								distance entre deux codes */
{float x;
x=10-10*distance/l_code;

return x;
}

/*------------------------------------------------------------------- CAUCHEMAR */
void cauchemar(struct liste_etats l,struct matrice M)
/* Pour ce type de rve (voir le module correspondant), 
on modifie temporairement la matrice de transition,
de manire  favoriser les transitions les moins probables
(mais nanmoins possibles).
*/
{
int 			i,j;
struct matrice 	Mt;

for (i=0;i<l_code;i++)
	{
	for (j=0;j<l_code;j++)
		{
		if (M.M[i][j]>0)
			{
			Mt.M[i][j]=1+max_trans-M.M[i][j];
			}
		else
			Mt.M[i][j]=0;	
		}
	Mt.M[i][i]=max_trans;
	}

reve(l,Mt);

}
/*------------------------------------------------------------------- CHERCHE_NOM */
int cherche_nom_etat(char nom_etat[l_nom],struct liste_etats liste)
/* Renvoie le rang de l'tat ou -1 s'il n'est pas trouv */
{
int i,n_max,comp;
char c2[l_nom];

n_max=liste.n_etats;
						
for (i=0;i<n_max;i++)  /* Recherche squentiellement dans la liste des tats */
	{
	strcpy(c2,liste.l[i].nom);
	comp=strcmp(c2,nom_etat);
	if( comp==0) return i;
	}

/* Etat non trouv */
return -1;
}

/*------------------------------------------------------------------- COEFF_RECOMM */
float coeff_recomm(int recomm) /* [-10,10] => [0,1] */
{float x;
         
x=recomm;
x=x/10;
return abs (x);
}

/*------------------------------------------------------------------- COEFF_RIGIDITE */
float coeff_rigidite(int rigidite) /* [0,100] => [0,1] */
{float x;
			
			/* Linaire */
x=rigidite;
x=(100-x)/100;
return x;
}
/*------------------------------------------------------------------- COHERENCE */
void coherence(struct liste_etats l0,struct matrice M0,struct liste_etats *l,struct matrice *M)
{
struct code 			code1,code2,code3;
int 					i;
int 					j;
int						k;
int 					n_tour;
struct code 			nouv_code;
int 					OK;
struct liste_etats 		lt;
struct matrice 			Mt;
struct liste_recomms_e 	r_e;

lt=l0;Mt=M0;
OK=0; 


for (i=0;i<lt.n_etats-1;i++) /* Pour chaque code ... */
	{
	code1=lt.l[i].code;
	
	for (j=i+1;j<lt.n_etats;j++) /*... on compare  tous les suivants */
		{
		code2=lt.l[j].code;
		OK=compare_codes(code1,code2);
			
		if (OK==1)            /* Si les codes sont gaux ... */
			{
			printf("\nDoublon de codes aux rangs %i et %i",i,j);
			printf("\n   je corrige (peut tre un peu longuet)");
								/* ... on gnre un nouveau code ... */
			n_tour=0;
			cree_code:
			if (n_tour>l_code)
				{
				printf("\n ATTENTION. Je n'arrive pas  crer un nouveau code d'tat");
				goto fin_coherence;
				}					
			nouv_code=cree_code();
			
								/* ... diffrent de tous les autres ... */
			
			for (k=0;k<l_code;k++)
				{
				code3=lt.l[k].code;
				OK=compare_codes(nouv_code,code3);
				if (OK==1) {n_tour=n_tour+1;goto cree_code;}
				
				}
								/* ... et on ralise la modification (qui implique de modifier
										aussi la matrice de transition) */
			r_e= genere_recomms(i,nouv_code,l0,M0,1);
			
			/* On choisit une rigidit constante, de valeur moyenne, et on traite deux fois */
			Mt=traite_recomms_e(r_e,Mt,2,50,0,&OK);
			
			if (OK==1) /* Si la matrice a pu tre modifie ... */
				{
				/* ... on mmorise l'tat modifi */
				
				lt.l[j].code=nouv_code;
				nouv_etat=1;
				metrique=0;
				}
			}
		}
	}
	fin_coherence:
	*l=lt;
	*M=Mt;
	
}
/*------------------------------------------------------------------- COMPARE_CODES */
int compare_codes(struct code code1,struct code code2)
/* Compare deux codes. Renvoie 1 s'ils sont gaux, 0 sinon */
{int i;

for (i=0;i<l_code;i++)
	{
	if (code1.code[i]!=code2.code[i]) return 0;
	}
return 1;
}

/*------------------------------------------------------------------- COMPARE_NOMS */
int	compare_noms(char nom1[l_code],char nom2[l_code]) /* Renvoie 1 si les noms sont gaux, 0 sinon */
{int i;

for (i=0;i<l_code;i++)
	{
	if (nom1[i]!=nom2[i]) return 0;
	}
return 1;

}

/*------------------------------------------------------------------- CONFIANCE_NOM */
float confiance_nom(float d,int long_code)
{float x;
x=1-d/long_code;
return x;
}



/*------------------------------------------------------------------- COPIE_CODE */
struct code copie_code(char code[l_code])
{int i; struct code c;
for (i=0;i<l_code;i++)
	{
	if (code[i]=='1') {c.code[i]=1;} else {c.code[i]=0;};
	}
return c;	
}

/*------------------------------------------------------------------- COUPLAGE_CODE_SIGNIF */
void couplage_code_signif()
/* Cherche  faire en sorte que pour tout couple d'tats la distance entre codes
soit en accord avec la distance de transition (cf. quasi-mtrique). On modifie donc
 la fois les codes et la matrice de transition, et ceci itrativement 
*/
{
int					choix;
struct code 		code_i;
struct code			code1;
int					cycle;
float				d_codes;
float 				ecart;
float				ecart_tot,ecart_tot1;
int					global;
int 				i;
int 				j;
int					k,k0;
struct liste_etats 	l0;
struct matrice		M0;
int					OK;
int					rang2;
float				ratio_D;
int					tour;

printf("\n 0 = un seul cycle de modifications");
printf("\n 1 = tant que la concordance s'amliore");
printf("\n Votre choix ? : ");
scanf("%i",&choix);
choix=MAX(MIN(1,choix),0);

printf("\n0 : dformation locale progressive (assez rapide) ");
printf("\n1 : dformation globale brutale  (plus fiable, mais longue)");
printf("\n2 : dformation globale progressive (encore plus fiable, mais trs longue)");
printf("\n Quel type de dformation voulez-vous (0,1,2) ? : ");
scanf("%i",&global);
global=MAX(MIN(2,global),0);

cycle=1;
while (cycle==1)
{

	M0=M; /* On mmorise des copies de la matrice de transition ... */
	l0=l; /* ... et de la liste des tats. Les modifications de seront rellement prises
		en compte que si cela vaut la peine (dcroissance de l'cart total */

	ecart_tot=0;
	ecart_tot1=0;

	if(inhib_metr==1) D=metrique_trans(l,M); /* Ici, il FAUT calculer la mtrique */

	for (i=0;i<l.n_etats;i++)
		{

		code_i=l.l[i].code;
		for (j=0;j<l.n_etats;j++)
			{
			if (j==i) continue; /* On ne traite pas les autotransitions, car la distance de codes
								est forcment nulle */
			printf("\n\n Code signifiant : tat rang %i => tat rang %i",i,j);						
								
			ratio_D=D.D[i][j]/D.infini;  /* Distance de transition, ramene sur [0,1] */
			d_codes=distance(code_i,l.l[j].code,type_dist); /* Distance de codes, sur [0,1] */
			ecart=ratio_D-d_codes; /* sur [-1,1] */
			printf("\n ratio mtrique %f, dist. de codes %f, cart %f",ratio_D,d_codes,ecart);
		
			if(ecart==0) continue;
	
			ecart_tot=ecart_tot+ecart*ecart; /* Incrmentation de l'cart global */
		

			k0=0;
			nouv_essai:	  /* Dans tous les cas, on ne modifie que le deuxime code */
	
			/* Si la distance de codes est trop grande, on la fait baisser 
		   en galant,  partir du rang k0, un bit diffrent
		   du second code */
	
			tour=0;
			diminue_ecart:
			
			if (ecart<0) 
				{
				
				k=alea(k0,l_code);
				
				if (code_i.code[k]!=l.l[j].code.code[k])
						{
						code1=l.l[j].code;
						code1.code[k]=code_i.code[k];
						/*k0=k+1;*/
						goto modif;
						}
				else
					{
					tour=tour+1;
					if (tour<=l_code)
						{
						goto diminue_ecart;
						}
					else
						{
						printf("\n Je laisse subsister un cart de %f pour les tats de rangs %i  et %i",ecart,i,j);
						return;
						}
					}
				}
		
	
			/* ... et inversement, si elle est trop petite, on l'augmente
			en diffrenciant un bit identique,  partir du rang k0 */
			
			if (ecart>0)
				{
				k=alea(k0,l_code);
				
				if (code_i.code[k]==l.l[j].code.code[k])
						{
						code1=l.l[j].code;
						code1.code[k]=1-code_i.code[k];
						/*k0=k+1;*/
						goto modif;
						}
				else
					{
					tour=tour+1;
					if (tour<=l_code)
						{
						goto diminue_ecart;
						}
					else
						{
						printf("\n Je laisse subsister un cart de %f pour les tats de rangs %i  et %i",ecart,i,j);
						return;
						}
					}
				}
		
	
			modif:
	
	/*
		printf("\n   code modifi : ");	
		affiche_code(code1);
	*/	
			/* On vrifie que le nouveau code n'existe pas dj */
			rang2=doublon_code(code1,l);
	
			if (rang2>=0)    /* S'il existe dj, on essaie une autre modification */
				{
				printf("\n le code existe dj : ");
			
				printf("\n nouvel essai");
				goto nouv_essai;
				}
	

			/* Le code n'est pas un doublon : on tente la modification  */
		
			modif_code(j,code1,&l,&M,100,1,global,10,&OK);

			if (OK!=1) /* Si elle n'est pas possible, on essaie une autre modification  */
				{
				goto nouv_essai;
				}
		
			D=metrique_trans(l,M); /* Ici, il faut recalculer la mtrique */
		
			/* On recalcule tout de suite le nouvel cart */
			d_codes=distance(code_i,l.l[j].code,type_dist); /* Distance de codes, sur [0,1] */
			ecart=ratio_D-d_codes; /* sur [-1,1] */
			printf("\n         nouvel cart %f",ecart);
			ecart_tot1=ecart_tot1+ecart*ecart;

			}
		
		}
		ecart_tot=sqrt(ecart_tot);
		ecart_tot1=sqrt(ecart_tot1);
		printf ("\n L'cart global distance de codes/distance de transition tait de %f",ecart_tot);
		printf ("\n                                             il est maintenant de %f",ecart_tot1);
	
		if (ecart_tot1>=ecart_tot)
			{printf("\n Pas d'amlioration => j'ANNULE les modifications");
			l=l0;
			M=M0;
			D=metrique_trans(l,M);
			cycle=0;
			}
		if (choix==0) cycle=0;
	}
}

/*------------------------------------------------------------------- CREE_CODE */
struct code cree_code()
{
struct code code;
int 		i;
int 		j;
int 		nb_1;

for (i=0;i<l_code;i++) code.code[i]=0; /* Met d'abord  zro le code */
nb_1=0;

init_code:
for (i=0;i<nbits_1;i++) /* Choisit au hasard n_bits_1 bits */
	{j=alea(0,l_code-1);
	if (alea(0,100)<50) 
		{nb_1=nb_1+1;code.code[j]=1;};   /* et les met ou non  1 avec une proba de 1/2 */
	}
if (l_code-nb_1>nbits_0) goto init_code; /* On n'admet pas un code avec trop de bits  0 */

return code;
}
/*------------------------------------------------------------------- CREE_ETAT */
struct liste_etats cree_etat(char nom_etat[l_nom],struct liste_etats l0)
/* Cre un nouveau code d'tat, pour le nom indiqu. Ajoute l'tat  la liste des tats nonables.
Le code est choisi au hasard
*/
{
struct 	etat 		a;
struct liste_etats 	lt;
int 				n_etats;
int 				rang;


lt=l0;
n_etats=l0.n_etats;

/* On vrifie qu'on a de bonnes chances de trouver un code non dj utilis */
max_etats=max_memo(l_code,nbits_1,nmax_etats,seuil_proba); /* Nb thorique d'tats acceptable */
if (n_etats>=max_etats)
	{
	printf("\n Attention, il y a dj %i tats ",n_etats);
	printf("\n Je ne suis pas cens en mmoriser plus de %f ",max_etats);
	printf("\n je risque d'avoir des difficults  crer un nouveau code :");
	printf("\n je vous conseille d'abandonner.");
	}

/* On vrifie que le nom de l'tat n'existe pas dj */
rang=cherche_nom_etat(nom_etat,lt);


if (rang<0)
{
	strncpy(a.nom,nom_etat,l_nom); /* On commence  crer un tat, en donnant le nom */

 	/* Choix du code au hasard. On suppose que le nombre de bits  1 est faible devant
            le nombre total de bits */
	init_code:
	a.code=cree_code(); /* Fin de cration de l'tat, en crant le code */
	
	rang=doublon_code(a.code,lt); /* On vrifie que ce n'est pas un doublon, par malchance */
	if (rang>=0) goto init_code; /* Si c'est le cas, on essaie d'en gnrer un autre
						ATTENTION:il y a boucle infinie ds que le nombre total d'tats
						 devient suprieur  2^l_code -1   */

	lt.n_etats=n_etats+1; /* Nouveau nombre d'tats */
	lt.l[n_etats]=a; /* Ajout de l'tat cr  la liste des tats */

	nouv_etat=nouv_etat+1;
	metrique=0;
	printf ("\nCration du nouvel tat nonable %s",a.nom);
	printf("   rang %i",lt.n_etats-1);
}


return lt;
}


/*------------------------------------------------------------------- DEMANDE_RIGID */
int demande_rigid(int type_rigid) 
{int rigidite;
if (type_rigid==0)
		printf("\nRigidit ? (entier de 0  100) : ");
	else
		printf("\nRigidit maximale ? (entier de 0  100) : ");
	scanf("%i",&rigidite);
	
rigidite=MAX(MIN(rigidite,100),0);
return rigidite;
}
	
/*------------------------------------------------------------------- DISTANCE */
float	distance(struct code a,struct code b,int type_dist) /* Calcule une distance entre deux codes */
{float d,inter,uni,scal,n1,n2,theta,lambda;int i;

if (type_dist==1) /* "Distance" en nergie d'activation. 
					Attention, cette mesure est asymtrique. C'est la "distance" de a vers b.
*/
	{
	d=0;
	for (i=0;i<l_code;i++)
		{
		if (a.code[i]==0 && b.code[i]==1) d=d+1;
		}
	return d ;
	}

if (type_dist==2) /* "Distance" ensembliste (entre 0 et 1) */
	{
	inter=0;uni=0;
	for (i=0;i<l_code;i++)
		{
		if (a.code[i]==1 && b.code[i]==1) inter=inter+1; /* Intersection */
		if (a.code[i]==1 || b.code[i]==1) uni=uni+1; /* Union */
		}
	d=1-inter/uni;
	return d ;

	}
	

if (type_dist==3) /* "Distance" angulaire (entre 0 et 1) */
	{
	scal=0;n1=0;n2=0;
	for (i=0;i<l_code;i++)
		{
		scal=scal+a.code[i]*b.code[i];
		n1=n1+a.code[i]*a.code[i];
		n2=n2+b.code[i]*b.code[i];
		}
	d=scal/sqrt(n1*n2); /* Cosinus */
	d=1-sqrt(1-d*d); /* Sinus */
	return d ;
	}
	
if (type_dist==4) /* "Distance" psycho-valide (entre 0 et 1) */
	{lambda=1.3;
	scal=0;n1=0;n2=0;
	for (i=0;i<l_code;i++) /* Calcul de l'angle */
		{
		scal=scal+a.code[i]*b.code[i];
		n1=n1+a.code[i]*a.code[i];
		n2=n2+b.code[i]*b.code[i];
		}
	d=scal/sqrt(n1*n2); /* Cosinus */
	theta=acos(d);     /* Angle */
	d=exp(-lambda*theta); /* Ressemblance simplifie (un seul paramtre) */
	d=1-d;
	
	return d ;

	}	

/* Par dfaut, distance de Hamming */

	d=0;
	for (i=0;i<l_code;i++)
		{
		if (a.code[i]!=b.code[i]) d=d+1;
		}
	return d ;	
	
}

/*------------------------------------------------------------------- DISTANCE_MIN */
float distance_min(struct code c, struct liste_etats l,int *rang,int type_dist)
{float d,dist; int i;
d=2*l_code;
for (i=0;i<l.n_etats;i++) /* Cherche le code nonable dont la "distance" 
							au code donn c est minimale
							donne le rang et renvoie cette distance
							*/
	{
	dist=distance(c,l.l[i].code,type_dist);
	if(dist<d) {*rang=i;d=dist;};
	}
return d;
}

/*------------------------------------------------------------------- DOUBLON_CODE */
int	doublon_code(struct code code,struct liste_etats l)
/* On compare le code  ceux de la liste. Renvoie le rang du doublon trouv, ou -1 sinon */
{int i,OK;
for (i=0;i<l.n_etats;i++)
	{
	OK=compare_codes(code,l.l[i].code);
	if (OK==1) return i;
	}
return -1;
}

/*------------------------------------------------------------------- ECRITURE_ETATS */
void ecriture_etats(FILE *file,struct liste_etats l)

{
int i,j,k;
struct etat a;char nom_code[l_ligne];


printf("\nEcriture des tats nomms (nonables)");

for (i=0;i<l.n_etats;i++)
	{
	a=l.l[i];
	/*Recompose l'enregistrement */
	fprintf(file,"%s/",a.nom);
	j=strlen(a.nom);
	strncpy(nom_code,a.nom,j); /* Copie du nom */
	nom_code[j]=sep;		/* Introduction du sparateur */
	
	for (k=0;k<l_code;k++) /* Copie du code */
		{
		fprintf(file,"%i",a.code.code[k]);
		}
		fprintf(file,"\n");
	}
}

/*------------------------------------------------------------------- ECRITURE_METRIQUE */
void ecriture_metrique(FILE *file,struct metrique D)
{
int i,j;

if (metrique==1)
	{
	printf("\nEcriture de la quasi-mtrique");
	fprintf(file,"%i\n",D.taille);
	fprintf(file,"%f\n",D.infini);

	for (i=0;i<D.taille;i++)
		{
		for (j=0;j<D.taille;j++)
			{
			fprintf(file,"%f\n",D.D[i][j]);
			}
		}
	}
}
/*------------------------------------------------------------------- ECRITURE_TRANS */
void ecriture_trans(FILE *file,struct matrice M)
{
int i,j; /*char ligne_mat[l_code];*/

printf("\n\n\nEcriture de la matrice de transition entre codes d'tats");

fprintf(file,"%i\n",M.taille);

for (i=0;i<M.taille;i++)
		{
		for (j=0;j<M.taille;j++)
			{
			fprintf(file,"%f\n",M.M[i][j]);
			}
		}


/*
ancienne mthode, pour max_trans<10

for (i=0;i<M.taille;i++)
	{
	
	for (j=0;j<M.taille;j++)
	if (M.M[i][j]>=0 && M.M[i][j]<=max_trans) ligne_mat[j]='0'+M.M[i][j];
	
	for (j=0;j<M.taille;j++) fprintf(file,"%c",ligne_mat[j]);
	fprintf(file,"\n");
	
	}
	
*/
}

/*------------------------------------------------------------------- EFFACE_ETATS */
struct liste_etats efface_etats()
{struct liste_etats lt;char reponse[1];

printf("\nVous tes bien certain(e) (Oui / Non) ? :  ");
scanf("%s",&reponse);

if (reponse[0]=='O' || reponse[0]=='o') 
	{
	lt.n_etats=0;
	nouv_etat=1;
	metrique=0;
	
	printf("\nFin d'effacement des tats nonables");
	

	return lt;
	}
}

/*------------------------------------------------------------------- ENERG_MAX */
float energ_max(struct matrice M) /* Calcule le stock d'nergie au-del duquel
									on ne peut esprer obtenir de nouvelles transitions */

{
int i;
int j;
float e;

e=0;
for (i=0;i<M.taille;i++)
	for (j=0;j<M.taille;j++)
		if (M.M[i][j]>0) e=e+max_trans/M.M[i][j];

return e;
}

/*------------------------------------------------------------------- ENONCE_CODE */
void enonce_code(struct code c, struct liste_etats l) /* Enonciation en clair d'un code d'tat 
                                en donnant le nom plus probable. Cherche l'tat nonable dont
								le code est le plus proche du code donn */ 

{
int rang;float d;

d=distance_min(c,l,&rang,type_dist);

printf("\nLe code ");
	affiche_code(c);
	printf (" correspond  l'tat %s (confiance = %f) ", l.l[rang].nom,confiance_nom(d,l_code));
	
etat_courant=rang; /* Pour affichage graphique de la constellation */
}


/*------------------------------------------------------------------- ENONCE_ETAT */
void enonce_etat(struct etat a, struct liste_etats l) /* Enonciation en clair d'un tat 
                                en donnant le nom plus probable. Cherche l'tat nonable dont
								le code est le plus proche du code donn */ 

{
int rang;float d;

d=distance_min(a.code,l,&rang,type_dist);
printf (" %s (confiance = %f) ", l.l[rang].nom,1-d/l_code);
etat_courant=rang;
	
}

/*------------------------------------------------------------------- GENERE_RECOMMS_E */
struct liste_recomms_e genere_recomms(int rang,struct code code1,struct liste_etats l,struct matrice M,int global)

/* Gnre des recommandations suite  une demande de mofification de code 
rang est le rang  de l'tat a dont on souhaite modifier le code
code1 est le nouveau code

Dans le cas "global" (global=1 ou 2), on gnre les recommandations correspondant  tous les tats nonables.
	
Dans le cas "local" (global=0), on ne gnre que les recommandations dont une des extrmits est l'tat 
	dont on modifie le code.
	
*/
{
struct etat 			a;
struct code 			code2;
float 					d;
int 					i;
int 					rang2; 
struct recomm_e 		recomm_e;
struct liste_recomms_e	r_e;

/*printf("\n genere_recomms. rang = %i, code = ",rang);affiche_code(code1);*/

a=l.l[rang];


r_e.n_recomms=0;

if (global==0) /* Rvision locale seulement */

	{
	/* Recommandations pour les transitions VERS cet tat */

		for (i=0;i<l.n_etats;i++) /* Pour chaque tat nonable ... */
			{
			code2=transition(l.l[i].code,M,seuil,10); /* ... on effectue une transition. */
	
			d=distance_min(code2,l,&rang2,type_dist); /* Cherche l'tat nonable le plus proche du
									rsultat de la transition */
/*									
	printf("\n");
affiche_code(code2);

printf("\n");
affiche_code(l.l[rang2].code);	
*/

			if (compare_noms(a.nom,l.l[rang2].nom)==1) /* S'il a le mme nom que l'tat dont on
												modifie le code (a) ... */
				{
													/* ... alors on gnre une recommandation */
				recomm_e.a=l.l[i];
				recomm_e.b=a;recomm_e.b.code=code1; /* Etat final : nom de a, mais nouveau code */
		
				recomm_e.avis=avis_d(d); /* Force de l'avis, fonction dcroissante de la distance */
		
	
				r_e.r[r_e.n_recomms]=recomm_e;
			r_e.n_recomms=r_e.n_recomms+1;
				
				if (r_e.n_recomms>nmax_recomms) goto fin_recomms; /* Fin prmature si dpassement mmoire */
		
				/* affiche_etat(recomm_e.a); affiche_etat(recomm_e.b);printf("\n force %i",recomm_e.avis); */
		
				}

			} /* Fin boucle i */

		/* Recommandation pour la transition courante (qui dpend de l'nergie) DEPUIS cet tat */

		recomm_e.a=a;
		recomm_e.a.code=code1; /* Etat initial : nom de a, mais nouveau code */
		code2=transition(a.code,M,seuil,10); /* Avec l'ancien code ... */
		d=distance_min(code2,l,&rang2,type_dist); /* ... et aprs la transition, on noncerait l'tat b de rang rang2 */
		
		if (rang2!=rang) /* Si c'est une autotransition, elle a dj t prise en compte dans la phase prcdente */
			{
			recomm_e.b.code=l.l[rang2].code;
			strcpy(recomm_e.b.nom,l.l[rang2].nom);

			recomm_e.avis=avis_d(d);

			r_e.r[r_e.n_recomms]=recomm_e;
			r_e.n_recomms=r_e.n_recomms+1;
			if (r_e.n_recomms>nmax_recomms) goto fin_recomms; /* Fin prmature si dpassement mmoire */
			}
		
		
	} /* Fin global==0 */

if (global>=1)/* En cas de rvision globale, reconsidre toutes les transitions issues des tats nonables */
	{
	
	for (i=0;i<l.n_etats;i++) 
		{
		recomm_e.a=l.l[i];  /* Pour chaque tat initial ... */
		code2=transition(l.l[i].code,M,seuil,10);/* ... on cherche l'tat final... */
		d=distance_min(code2,l,&rang2,type_dist); /* ... et le rang de l'tat nonable le plus proche */
		
/*
printf("\n");
affiche_code(l.l[i].code);		
printf("  ");
affiche_code(code2);
printf("  ");
affiche_code(l.l[rang2].code);	
*/								
		
		
									/*  (ne pas oublier d'utiliser le nouveau code pour l'tat a) */
		if (i==rang) recomm_e.a.code=code1; /* qu'il soit en origine (initial) */
		if (rang2==rang) {recomm_e.b.code=code1;} else recomm_e.b.code=l.l[rang2].code;/* ou en extrmit (final) */
		
		strcpy(recomm_e.b.nom,l.l[rang2].nom);

		recomm_e.avis=avis_d(d);

		r_e.r[r_e.n_recomms]=recomm_e;
		r_e.n_recomms=r_e.n_recomms+1;
		if (r_e.n_recomms>nmax_recomms) goto fin_recomms; /* Fin prmature si dpassement mmoire */
		
	/*printf("\n %s  =>  %s ",recomm_e.a.nom,	recomm_e.b.nom); */
		
		}
	}


	
printf("\n %i recommandations gnres",r_e.n_recomms);
return r_e;	

fin_recomms:
printf("\n ATTENTION, je n'ai pas pu gnrer plus de %i recommandations (cf. variable nmax_recomms)",r_e.n_recomms);
return r_e;
	
}

/*------------------------------------------------------------------- GRAPHES */
void GRAPHES(struct liste_etats l,struct matrice M)
{
int decal;
int i,k,max;

affiche_trans_etats_graph(l,M);	
	
	/* Positionne les noeuds du graphe de "l'tat d'esprit" */
decal=12;
max=5; /* Nombre max de noeuds/ligne */	
pos_x[0]=decal;
pos_y[0]=30;
k=0;
for (i=1;i<l_code;i++) 
	{
	pos_x[i]=pos_x[i-1]+decal;
	pos_y[i]=pos_y[i-1];
	k=k+1;
	if (k==max)
		{
		k=0;
		pos_x[i]=pos_x[0];
		pos_y[i]=pos_y[i-1]+decal;
		}
	}

}	
/*------------------------------------------------------------------- INITIALISE_TRANS */
struct matrice initialise_trans(struct liste_etats l)
/* Chaque lment vaut de 0  max_trans. L'nergie ncessaire pour la transition est de la forme max_trans/valeur.
 0 indique une transition impossible (max_trans/0=infini), 
 et max_trans indique la transition la plus facile possible (1 unit d'nergie) */

{
int 			choix;
int 			i;
int 			j;
int 			jj;
struct matrice 	Mt;
int 			nval;
char 			reponse[1];


printf("\nVous tes bien certain(e) (Oui / Non) ? :  ");
scanf("%s",&reponse);

if (reponse[0]=='O' || reponse[0]=='o') 
	{
	printf("\n0 = initialisation diagonale (que les auto-activations)  ");
	printf("\n1 = initialisation alatoire");
	printf("\nVotre choix ? ? :  ");
	
	scanf("%i",&choix);
	choix=MAX(MIN(1,choix),0);
	
	Mt.taille=l_code;
	
	/* Mise  zro de la matrice */
	for (i=0;i<l_code;i++) for(j=0;j<l_code;j++) Mt.M[i][j]=0;
	
	if (choix==0) /* Initialisation diagonale */
		{
		for (i=0;i<l_code;i++) Mt.M[i][i]=max_trans;
		goto fin_init;
		}
	
	if (choix==1) /* Initialisation alatoire */
		{
		/* On fait un choix alatoire de quelques liens */
		for (i=0;i<l_code;i++) 
			{nval=0;
			nouvelle_ligne:
			for (j=0;j<nbits_1;j++)
				{
				jj=alea(0,l_code);
				/*if (i!=jj) {Mt.M[i][jj]=MIN(max_trans,alea(1,10));nval=nval+1;};*/
				 /* et on leur met une valeur alatoire en interdisant l'auto-excitation ! */
				
				Mt.M[i][jj]=MIN(max_trans,alea(1,10));nval=nval+1; /* Ici on admet l'auto-excitation */
				
				};
			if (nval==0) goto nouvelle_ligne;
			};
			Mt.M[i][i]=max_trans; /* A dfaut, auto-excitation */
		}
	
	
	
/* On assure la transition facile de chaque tat vers lui-mme */

	Mt=auto_trans(l,Mt);

	fin_init:
	nouv_trans=nouv_trans+1;metrique=0;
	
	printf("\nFin d'initialisation de la matrice de transition");
	return Mt;
	}
}

/*------------------------------------------------------------------- ITOA */
struct chaine itoa(int number) /* Conversion entier => chaine de caractres */
{
struct chaine c;
sprintf(c.c,"%d",number);
return c;
}

/*------------------------------------------------------------------- LECTURE_ETATS */
struct liste_etats lecture_etats(FILE *file)
{
int i,j,k;
struct etat a;char nom_code[l_ligne];
struct liste_etats lt;

printf("\nLecture des tats nomms (nonables)");
j=0;


while (fscanf(file,"%s\n",nom_code)==1) /* while (!feof(file))
 										fscanf(file,"%s\n",nom_code); */
	{
	/* Spare le nom et le code */
	for (i=0;i<l_ligne;i++)
		{
		if (nom_code[i]==sep) goto suite;
		}
	suite:
	
	strncpy(a.nom,nom_code,i);  /*Copie le nom */
	
	
	a.nom[i]=fin;
	
	 /* Copie le code */
		
	for (k=0;k<l_code;k++)
		{
		if (nom_code[i+1+k]=='1') {a.code.code[k]=1;} else {a.code.code[k]=0;};
		}

	
	lt.l[j]=a;
	j=j+1;
	}
lt.n_etats=j;
return lt;

	
}

/*-------------------------------------------------------------------LECTURE_METRIQUE */
struct metrique lecture_metrique(FILE *file)
{
int i,j;
char ligne[20];
struct metrique Dt;

printf("\nLecture de la dernire quasi-mtrique");

fscanf(file,"%s\n",ligne);
Dt.taille=atoi(ligne);
fscanf(file,"%s\n",ligne);
Dt.infini=atof(ligne);

for (i=0;i<Dt.taille;i++)
	{
	for (j=0;j<Dt.taille;j++)
		{
		fscanf(file,"%s\n",ligne);
		Dt.D[i][j]=atof(ligne);
		}
	}
printf("\n  Attention, elle n'est peut-tre pas  jour");
return Dt;


}
/*------------------------------------------------------------------- LECTURE_QUESTIONS */
struct liste_questions lecture_questions(FILE *file)
/* Chaque enregistrement du fichier a la structure suivante :
nom
*/
{
int j;char nom[l_nom];
struct question question;
struct liste_questions qt;


printf("\nLecture des questions");
j=0;


while (fscanf(file,"%s\n",nom)==1) 
	{
	
	strcpy(question.nom,nom);
	
	/* Stocke la question */
	qt.q[j]=question;
	j=j+1;
	}

qt.n_questions=j;
return qt;

	
}

/*------------------------------------------------------------------- LECTURE_RECOMMS */
struct liste_recomms lecture_recomms(FILE *file)
/* Chaque enregistrement du fichier a la structure suivante :
nom1/nom2/avis
l'avis tant un nombre entier entre 0 et 10
*/
{
char 	c1[2];
int 	i;
int 	ideb;
int 	j;
int 	k;
char 	ligne[l_recomm];
struct liste_recomms rt;
int		ll;
struct recomm recomm;

printf("\nLecture des recommandations");
j=0;


while (fscanf(file,"%s\n",ligne)==1) /* while (!feof(file))
 										fscanf(file,"%s\n",nom_code); */
	{
	ll=strlen(ligne);
	/* Cherche le premier nom */
	for (i=0;i<l_ligne;i++)
		{
		if (ligne[i]==sep) goto suite;
		}
	suite:
	
	strncpy(recomm.nom1,ligne,i);  /*Copie le premier nom */
	
	recomm.nom1[i]=fin;
	
	/*printf("\nnom1 %s ",recomm.nom1); */
	
	ideb=i+1;
	for (i=ideb;i<l_ligne;i++)
		{
		if (ligne[i]==sep) goto suite2;
		}
	suite2:
	
	
	/* Copie le deuxime nom */
	for (k=0;k<i-ideb;k++) recomm.nom2[k]=ligne[ideb+k];
	recomm.nom2[k]=fin;
	
		 /*printf("\nnom2 %s ",recomm.nom2);*/	
	
	/* Copie l'avis */
	
	c1[0]=ligne[i+1];
	if (ll>=i+1) c1[1]=ligne[i+2];
	if (ll>=i+2) c1[2]=ligne[i+3];
	
	recomm.avis=atoi(c1);
	recomm.avis=MAX(MIN(10,recomm.avis),-10);
	
		/*printf("\navis %i ",recomm.avis);*/
	stocke:	
	/* Stocke la recommandation */
	rt.r[j]=recomm;
	j=j+1;
	}

rt.n_recomms=j;
return rt;

	
}
/*------------------------------------------------------------------- LECTURE_TRANS */
struct matrice lecture_trans(FILE *file)
{
int 	i,j;
/*char 	ligne_mat[l_code];*/
char 	ligne[20];
struct 	matrice Mt;
int 	n_ligne; 

/* Chaque lment vaut de 0  max_trans. L'nergie ncessaire pour la transition est de la forme max_trans/valeur.
 0 indique une transition impossible (max_trans/0=infini), 
 et max_trans indique la transition la plus facile possible (1 unit d'nergie) */

printf("\nLecture de la matrice de transition entre codes d'tats");

fscanf(file,"%i\n",&n_ligne);
Mt.taille=n_ligne;

if (n_ligne!=l_code)
	{
	printf("\nATTENTION, la taille de  matrice de transition stocke (%i) ne correspond pas",n_ligne);
	printf("\n			   la longueur du code des tats (l_code).");
	printf("\n   Je dmarre avec une matrice vide.");
	Mt.taille=0;
	return Mt;
	}

for (i=0;i<Mt.taille;i++)
	{
	for (j=0;j<Mt.taille;j++)
		{
		fscanf(file,"%s\n",ligne);
		Mt.M[i][j]=atoi(ligne);
		}
	}


/* ancienne mthode, pour lments <10 
for (i=0;i<n_ligne;i++)
	{
	fscanf(file,"%s\n",ligne_mat);
	
	for (j=0;j<Mt.taille;j++)
		{
		c[0]=ligne_mat[j];
		Mt.M[i][j]=atoi (c); 
		}
	
	}
	
*/
	
return Mt;
	
}

/*------------------------------------------------------------------- LONG_CHAINE */
int long_chaine(char chaine[l_ligne])
{
int i;
i=0;
while (chaine[i]!=fin) {i=i+1;};
return i;
}

/*------------------------------------------------------------------- MAX */
float MAX(float a,float b)
{
if (a>b) return a; return b;
}

/*------------------------------------------------------------------- MAX_MEMO */
int	max_memo(int long_code,int nb_bits_1,int nb_max_etats,float seuil_proba)
/* Calcule le nombre maximal d'tats qu'il est raisonnable de mmoriser */
{
float 	c;
int 	i;
int		n;
int 	n_bit;
float 	n_etats;

/* Au maximum, on peut gnrer le nombre de combinaisons de long_code bits
nb_bits_1 par nb_bits_1
plus
le nombre de combinaisons de long_code bits
nb_bits_1-1 par nb_bits_1-1
plus
etc.

 */

c=1;

for (n=0;n<nb_bits_1-1;n++)
	{
	n_bit=nb_bits_1-n;
	for (i=0;i<n_bit;i++)
		{
		c=c*(long_code-i);
		}

	}

/* On calcule la proba de gnrer un doublon en fonction du nombre d'tats ...
 ... et on crit qu'elle doit tre au plus gale au seuil donn */ 

n_etats=c*seuil_proba;

/* On tient compte de la limitation "matrielle" de stockage */
n_etats=MIN(n_etats,nb_max_etats);

return floor (n_etats);
}

/*------------------------------------------------------------------- MAX_TRANS */
int max_trans_ligne(struct matrice M, int ligne)
/* Rang du plus grand lment non nul de la ligne. -1 s'ils sont tous nuls.
 */
{
int 	j;
int		rang;
float  	max;

max=0;
rang=-1;
for (j=0;j<M.taille;j++)
	{
	if (M.M[ligne][j]>max)
		{
		max=M.M[ligne][j];
		rang=j;
		}  
	}
return rang;
}
/*------------------------------------------------------------------- METRIQUE_TRANS */
struct metrique metrique_trans(struct liste_etats l,struct matrice M)  /* Calcule toutes les distances de transition
						  			entre tats, en faisant varier le niveau d'nergie */
{
struct etat 	a;
struct code 	code;
float 			dist;
struct metrique Dt;
int 			e;
float 			e_max;
float 			f0;
int 			i;
int				ie_max;
int 			j; 
int 			n_calcul;
int 			rang;
float 			s0;
float			xe;


Dt=D; /* Mtrique variable locale = mtrique variable globale */
if (metrique==1) return Dt; /* Si dj cacul, on ne fait rien ! */

s0=stock_energ ; /* Mmorise le stock d'nergie, pour le restituer en fin de traitement */
f0=flux_energ ; /* Mmorise le flux d'nergie */
flux_energ=1; /* On minimise temporairement le flux d'nergie */

e_max=energ_max(M); /* Calcule l'nergie maximum  envisager */

Dt.taille=l.n_etats; /* Stocke la taille de la matrice de mtrique... */
Dt.infini=e_max+1;      /* ... et la valeur "infini" */

for (i=0;i<Dt.taille;i++)		/* Initialise les distances  "infini" */
	{
	for (j=0;j<Dt.taille;j++)
		Dt.D[i][j]=Dt.infini;
	}

ie_max=floor(e_max);	
n_calcul=l.n_etats*ie_max;


printf("\n\n Quasi-mtrique. Temps de calcul %i x %i = %i ",l.n_etats,ie_max,n_calcul);

for (i=0;i<l.n_etats;i++)  /* Pour chaque tat nonable origine a ... */
	{
	/** Not  Inference; **/
	a=l.l[i];
	for (e=1;e<ie_max;e++) /* Pour chaque niveau d'nergie */
		{	/* On note la transition faisable, s'il y en a une.A noter que pour l'instant,
			 on ne module pas par le niveau de confiance de l'nonciation (fonction dcroissante de dist). */
		stock_energ=e;
		xe=e;				
		code=transition(a.code,M,seuil,10); /* Effectue la transition, en logique parfaite */
		dist=distance_min(code,l,&rang,type_dist); /* Trouve l'tat nonable le plus proche */
		Dt.D[i][rang]=MIN(xe,Dt.D[i][rang]); /* Mmorise la plus petite distance */
		
		/*printf("\n i,rang,D %i, %i, %f",i,rang,Dt.D[i][rang]);*/

		}
	n_calcul=n_calcul-ie_max;
	printf("\n                                  reste %i",n_calcul);
	/**  Inference; **/	
	}

stock_energ=s0; /* Remet  jour le stock d'nergie ... */
flux_energ=f0; /* ... et le flux d'nergie */
metrique=1; /* Le calcul de la mtrique a t fait */


return Dt;
}

/*------------------------------------------------------------------- MIN */
float MIN(float a,float b)
{
if (a<b) return a; return b;
}

/*-------------------------------------------------------------------  MODIF_CODE */
void modif_code(int rang,struct code code1,struct liste_etats *l,struct matrice *M,int rigid_max,int type_rigid,int global,int logique,int *OK)
/* "rang" est le rang de l'tat "a" dont on souhaite modifier le code
"code1" est le nouveau code
On boucle au plus autant de fois qu'il y a d'tats nonables
Dans le cas "global" (global=1), on gnre les recommandations correspondant  tous les tats nonables
	et on prende le code modifi tel quel
Dans le cas "local" (global=0), on ne gnre que les recommandations dont une des extrmits est l'tat 
	dont on modifie le code, mais, en contre-partie, on itre en faisant une modification progressive
	du code, bit par bit.
*/
{
struct etat 			a;
struct code				liste_codes[l_code];
struct code 			code2,code3,code_nc;
float d;
int						i,i0;
struct liste_etats 		lt;
struct matrice 			Mt;
struct liste_recomms_e	r_e,r_e0;
int 					n_recomms2;
int 					n_tent_max,n_tent_part,n_tent_tot;
int						nb_codes;
int						nc;
int 					OK2;
int						rang2;
float					rigid;
float					taux_perte;

int bidon;

lt=*l;
Mt=*M;
n_tent_tot=0;


/* Phase 1 : on gnre les codes transitoires */

if (global==1)  /* Pas de code transitoire dans le cas global brutal */
	{
	nb_codes=1;
	liste_codes[0]=code1;
	}
else			/* Dans le cas local et le cas global progressif, 
					chaque code diffre du prcdent d'un bit seulement */
	{
	code2=lt.l[rang].code;
	nb_codes=0;
	i0=0;
	code3=code2;
	
	nouveau_code:
	
	
	for (i=i0;i<l_code;i++)
		{
		if (code2.code[i]==code1.code[i]) continue;
			{
			code3.code[i]=code1.code[i];
			i0=i;
			code2=code3;
			liste_codes[nb_codes]=code2;
			nb_codes=nb_codes+1;
			goto nouveau_code;
			}

		}

	}
	
/*for (i=0;i<nb_codes;i++) {printf("\n");affiche_code(liste_codes[i]);};

scanf("%i",&bidon);	*/
	

/* Phase 2 : on itre les modifications */

for (nc=0;nc<nb_codes;nc++)
	{
	code_nc=liste_codes[nc];
	a=lt.l[rang]; /* Etat dont le code est  modifier */

/*	printf("\n code_nc"); affiche_code(code_nc);

	printf("\n code  a"); affiche_code(a.code);
scanf("%i",&bidon);	*/

/*printf("\n rang %i, global %i",rang,global);
scanf("%i",&bidon);*/

		r_e0=genere_recomms(rang,code_nc,lt,Mt,global); /* Gnration des recommandations ncessaires pour dformer
									le moins possible l'espace cognitif */ 					
									
	n_tent_max=MAX(lt.n_etats,r_e0.n_recomms*(r_e0.n_recomms-1)); /* On value une limite max du nombre de tentatives */
	d=distance(a.code,code_nc,type_dist);
	rigid=rigid_max*(1-d); /* On se donne une rigidit d'autant plus grande que les deux codes sont dj proches */

	traite_complet:
	r_e=r_e0;
	n_tent_part=0;
									
	traite_partiel:
	
	printf("\n\n Essai %i/%i ",n_tent_part+1,n_tent_max);							
	Mt=traite_recomms_e(r_e,Mt,1,rigid,type_rigid,&OK2); /* Traitement de ces recommandations.
													Noter la rigidit fonction de la distance entre codes */

	*OK=OK2;
	if (OK2==1) /* Si la matrice a pu tre modifie ... */
		{
		/* ... on mmorise l'tat modifi */
		a.code=code_nc;
		lt.l[rang]=a;
		nouv_etat=1;
		metrique=0;
		}
	else
		{
		printf("\n Modification de code impossible");
		return ;
		}
	
	/* On contrle le rsultat */
	controle:
	printf("\nContrle du rsultat");

	n_recomms2=0;

	for (i=0;i<r_e.n_recomms;i++)	/* Pour chacune des recommandations ...*/
		{	
		code2=transition(r_e.r[i].a.code,Mt,seuil,10); /* Effectue la transition depuis l'tat initial ... */
		d=distance_min(code2,lt,&rang2,type_dist); /* ... on cherche le rang de l'tat nonable le plus
												proche du rsultat */
	
		code3=lt.l[rang2].code;    /* ... et son code. Cet tat doit tre le second de la recommandation */
	
		

/*
printf("\n");
affiche_code(r_e.r[i].a.code);
printf("  ");
affiche_code(code2);
printf("  ");
affiche_code(code3);	
*/
	
		if (compare_codes(code3,r_e.r[i].b.code) !=1) /* On vrifie que la recommandation est satisfaite ...
											... et sinon on la reprend. */
			{
			printf("\n %s => %s ",r_e.r[i].a.nom,r_e.r[i].b.nom);
			printf("    on trouve en fait  %s ",lt.l[rang2].nom);	

			r_e.r[n_recomms2].a=r_e.r[i].a;
			r_e.r[n_recomms2].b=r_e.r[i].b;
			r_e.r[n_recomms2].avis=r_e.r[i].avis;
			n_recomms2=n_recomms2+1;
			}
		else
			{
			/*
			printf("\n %s => %s ",r_e.r[i].a.nom,r_e.r[i].b.nom);
			printf("   OK");
			*/
			}
		}

	if (n_recomms2==0 && r_e.n_recomms==r_e0.n_recomms) goto fin_modif_code; /* Le traitement complet est parfait */

	if (n_recomms2==0 && r_e.n_recomms<r_e0.n_recomms) /* Le traitement partiel est bon, mais il faut revoir l'ensemble */
		{
		n_tent_tot=n_tent_tot+1;
		if(n_tent_tot<n_tent_max)
			{
			printf ("\n Je refais un contrle global");
			r_e=r_e0;
			goto controle;
			}
		else
			{
			{printf("\n ATTENTION, certains apprentissages ont pu tre perdus");
			goto fin_modif_code;} 
		
			}
		}
	
	if (n_recomms2>0) /* Il reste des recommandations non satisfaites */
		{
		n_tent_part=n_tent_part+1;
		if (n_tent_part<n_tent_max)
			{printf("\n %i recommandation(s) non satisfaite(s)",n_recomms2);
			r_e.n_recomms=n_recomms2;
		 	goto traite_partiel;}
		else
			{printf("\n ATTENTION, certains apprentissages ont pu tre perdus");
			goto fin_modif_code;} 
		}	

	
	fin_modif_code:


	taux_perte=n_recomms2/r_e0.n_recomms;

	/* affiche_trans(Mt);affiche_etats(lt);*/
	/* printf("\n stock energ %f, seuil %f",stock_energ,seuil);*/

	if (10*taux_perte>10-logique) /* Trop de perte, on ne modifie rien */
		{
		printf("\n Trop de perte d'information : je ne modifie plus rien ");
		goto fin_prematuree;
		}
	else  /* Suffisamment peu de perte : on modifie */
		{
		*l=lt;
		*M=Mt;
		}
	} /* Fin boucle nc */
	
fin_prematuree:;
}	
/*-------------------------------------------------------------------  MODIF_ETAT */
struct liste_etats modif_etat(struct liste_etats l)
{struct liste_etats lt;char nom[l_nom];int rang0,rang;
lt=l;
/* Choix de l'tat  modifier */ 

printf("\nEtat  modifier ?: ");scanf("%s",&nom);

/* Recherche si cet tat existe dj */

rang0=cherche_nom_etat(nom,l);
if (rang0<0) 
	{
	/* L'tat n'est pas nonable. On abandonne  */
	printf("\nDsol, je ne connais pas cet tat.");
	return l;
	}
	
 /* L'tat  modifier est bien nonable */
printf("\nNouveau nom ?: ");scanf("%s",&nom);

/* Recherche si cet tat existe dj */

rang=cherche_nom_etat(nom,l);

if (rang>=0)
	{
	printf("\nDsol, cet tat existe dj.");
	return l;
	}

strcpy(lt.l[rang0].nom,nom);
printf("\n   modification faite");
nouv_etat=1;
metrique=0;
return lt;
}
/*------------------------------------------------------------------- MODIF_TRANS */
struct matrice	modif_trans(struct matrice M0,struct etat a,struct etat b,int recomm,int rigidite,int type_rigid,int *OK)
/* La recommandation est une valeur entire de valeur absolue entre 1 et 10 
(c'est la "force" de la recommandation. Si elle vaut  zro, on n'est pas cens modifier !).

a est l'tat initial
Si la recommandation est positive b est un tat suivant souhait.
Si la recommandation est ngative b est un tat suivant  viter. 
--------------------------------------------------
Cas particulier d'un tat initial commenant par *  (signifiant "n'importe quel tat")

Si la recommandation est positive, l'tat b est une "ide fixe"
Si la recommandation est ngative, l'tat b est "tabou".
--------------------------------------------------
La rigidit (entier entre 0 et 100) module la modification. Plus elle est leve, plus la
modification de la matrice est faible.

*/
{
struct code 	code1,code2,codeb;
float			c1,c2;
int				cas;
float			coeff;
int 			delta_bit;
float	 		delta_M;
int 			i;
int 			j;
char 			joker[1];
struct matrice 	M;
int 			non_nul;


joker[0]='*';
*OK=1; /* A priori, on suppose que a va marcher ... */

/* printf("\n\nTentative de modification de la matrice des transitions");
printf("\n\nPour mmoire :");
printf("\nEtat initial : %s",a.nom);
printf("\nEtat souhait : %s",b.nom);
printf("\nRecommandation (0  10) : %i",recomm);
printf("\nRigidit (de 0  100) : %i",rigidite);
*/

printf("\n Traitement de  %s  => ",a.nom);
printf("%s",b.nom);
printf(" (force %i)",recomm);

M=M0;

code1=a.code; /* Code initial */
code2=transition(code1,M0,seuil,logique); /* Code final effectivement trouv */
codeb=b.code; /* Code final souhait (recommandation positive)
							ou  viter (recommandation ngative) */
							
c1=coeff_recomm(recomm);

if (recomm>0 && a.nom[0]!=joker[0])
	{
	/*Cas d'une recommandation POSITIVE et d'un tat initial UNIQUE */
	/* 
	(A) On compare bit  bit les codes trouv (code2) et souhait (codeb) 

	(B) Si le bit de code2 est  1 alors que celui de codeb est  0 (delta_bit=1), c'est que le nud
	est activ  tort. On regarde ses ascendants actifs et on augmente la rsistance 
	liens correspondants (de qui revient  diminuer les valeurs dans les lignes de la matrice,
	qui reprsentent des conductances).

	(C) Si le bit de code2 est  0 alors que celui de codeb est  1 (delta_bit=-1), c'est que le nud
	devrait tre activ. On regarde ses ascendants actifs et on diminue la rsistance 
	des liens correspondants (on augmente la valeur dans la matrice);

	(D) la modification est d'autant plus faible que la rigidit est importante,
	(E)la modification est d'autant plus grande que la valeur de la recommandation est grande.
	*/
	cas=1;
	}

if (recomm<0 && a.nom[0]!=joker[0])
	{

	/* Cas d'une recommandation NEGATIVE et d'un tat initial UNIQUE 

	(A) On compare bit  bit les codes trouv (code2) et  viter (codeb) 

	(B) Si le bit de code2 et celui de codeb sont diffrents (delta_bit=1 ou -1), c'est parfait.


	(C) Si les deux bits sont gaux (delta_bit=0)  1, c'est que le nud
	est activ  tort. On regarde ses ascendants actifs et on augmente la rsistance 
	liens correspondants (de qui revient  diminuer les valeurs dans les lignes de la matrice.

	(D) Si les deux bits sont gaux (delta_bit=0)  0 c'est que le nud
	devrait tre activ. On regarde ses ascendants actifs et on diminue la rsistance 
	des liens correspondants (on augmente la valeur dans la matrice);

	(E) la modification est d'autant plus faible que la rigidit est importante,
	(F)la modification est d'autant grande que la valeur absolue de la recommandation est grande.
	*/
	cas=2;
	}	

	for (i=0;i<M.taille;i++)
		{
		delta_bit=code2.code[i]-codeb.code[i];
		if ((cas==1 && delta_bit!=0) || (cas==2 && delta_bit==0)) 
						/* Si les deux bits ne sont PAS gaux et que la recommandation est positive
							ou si les deux bits SONT gaux mais que la recommandation est ngative 
							on modifie la valeur du lien (conductance )
						*/
			{
			for (j=0;j<M.taille;j++) /*... pour chaque ascendant ... */
				{
				/*printf("\n i,j,code1(j) %i, %i, %i",i,j,code1.code[j]);*/
				if (code1.code[j]==1) /*...  actif ...*/
					{
					/*------------------------- Modification  seuil */
					/* ?????????  complter pour les recommandations ngatives ??????? */ 
					if (type_modif_trans==0)  
						{
						delta_M=-max_trans*delta_bit*coeff_recomm(recomm)*coeff_rigidite(rigid(j,rigidite,type_rigid))  ;
									 /* Rigidit variable */
						M.M[j][i]=MIN(MAX(M.M[j][i]+delta_M,0),max_trans); /*... on modifie la valeur du lien. */
						/*M.M[j][i]=MIN(MAX(M.M[j][i]+delta_M,1),max_trans);*/
						}
			
					/*------------------------- Modification progressive (au plus gale  +-max_trans ) */	
					if (type_modif_trans==1) 
						{
				
						c2=coeff_rigidite(rigid(j,rigidite,type_rigid));
						coeff=c1*c2;
						
						/* Augmentation de la conductance :
						- recommandation positive (cas=1) et on obtient 0 et on voudrait 1 (delta_bit=-1)
						- recommandation ngative (cas=2) et on obtient 0 et on voudrait viter 0 (delta_bit=0 et code2.code[i]=0)
						
						*/
						
						if ((cas==1 && delta_bit==-1) || (cas==2 && delta_bit==0 && code2.code[i]==0))
							{
							/*printf("\n c1 %f, c2 %f, coeff %f, augmentation %f",c1,c2,coeff,M.M[j][i]);*/
							delta_M=(coeff*(max_trans-M.M[j][i]));
							M.M[j][i]=M.M[j][i]+delta_M;
							 /*printf("  %f ",M.M[j][i]);*/
							}
						
						
						else/* Diminution de la conductance */
							{
							/*printf("\n diminution %f",M.M[j][i]);*/
							delta_M=coeff*M.M[j][i];
							M.M[j][i]=M.M[j][i]-delta_M; 
							/*printf("  %f ",M.M[j][i]);*/
							}
							
						}
					}
				}
			}
		non_nul=max_trans_ligne(M,i);
		if (non_nul<0) /* Toute la ligne est nulle */
			{
			
			M.M[i][i]=1 ; /* Pas moyen d'avoir autre chose que l'auto-transition */
			
			/* *OK=0;*/ /* ... mais parfois a ne marche pas */
			
			}
		}
	nouv_trans=1;
	metrique=0;
	GRAPHES(l,M);
	return M;

}

/*------------------------------------------------------------------- MONOLOGUE */
void monologue(struct liste_etats l,struct matrice Mt,int rang,int n_trans,float seuil,int logique)
/* Suite de "n_trans" transitions  partir de l'tat de rang "rang" */
{
struct code	code1,code2;
float		max_energ;
int 		n;
int 		r;
float 		s;

etat_courant=rang;

max_energ=energ_max(Mt);

/*for (n=0;n<l_code;n++) {code1.code[n]=l.l[rang].code.code[n];}; */
code1=l.l[rang].code;  /* Initialise le code */

/*
printf ("\n stock_energ %f",stock_energ);
enonce_code(code1,l);
*/

s=stock_energ;

for (n=0;n<n_trans;n++) /* Pour chaque transition ... */
	{
	code2=transition(code1,Mt,seuil,logique); /* ... calcul du nouveau code ... */
	enonce_code(code2,l); /*... nonciation, plus ou moins certaine */
	
	/* Plus la logique est forte, plus la proba de recentrer sur l'tat nonable trouv
	est leve */
	
	r=alea(0,10); /* Logique prend ses valeurs sur [0,10] */
	
	if (r<=logique)
		{code1=l.l[etat_courant].code;} /* On recentre sur l'tat nonable trouv
								A noter que etat_courant a t mis  jour dans enonce_code() */
	else
		{code1=code2;}; /* On reste sur l'tat effectivement trouv */
	
	if (compare_codes(code1,code2)!=1) 
		{
		stock_energ=s;
		continue;
		}
	else /* Si on se rpte, on augmente l'nergie */
		{
		stock_energ=stock_energ+flux_energ;
		if (stock_energ<max_energ) 
			{continue;}
		else
			{
			printf("\n Arrt sur ide fixe");
			goto fin_monologue;
			};
		};
	};
	fin_monologue:;	
}

/*------------------------------------------------------------------- NOMS_BIT */
void noms_bit()
/* Pour la visualisation, affecte des noms aux bits des codes initial et final
Utilise les variables globales l_code et nom_bit

On utilise une "simulation" de la fonction itoa (inexistante en ANSI C) 

*/
{
int i;

for (i=0;i<2*l_code;i++)
	{
	nom_bit.c[i]=itoa(i);
	}

}

/*------------------------------------------------------------------- NOMS_CODES */
struct liste_etats noms_codes(FILE *file,struct liste_etats l)
{struct liste_etats lt;char nom[l_nom];
/* Lecture d'une liste de nouveaux noms sur fichier */
printf("/n/nLecture de nouveaux noms et attribution de codes");
lt=l;
while (fscanf(file,"%s\n",nom)==1) 
	{
	lt=cree_etat(nom,lt);
	}
return lt;
}

/*------------------------------------------------------------------- QUESTIONS */
void questions(char nom_fichier[l_nom],FILE *fichier,struct liste_etats l,struct matrice M)
								    /* Rpond  une liste de questions (fichier questions.TXT) */
{int OK,i,rang;
struct liste_questions q;struct question question;
struct etat a,b;
/* La liste est de la forme 
nom_d_etat_initial
*/

fclose(fichier);
fichier=fopen(nom_fichier,"r");
OK=1;

q=lecture_questions(fichier);

printf("\n\nRponses : ");

for (i=0;i<q.n_questions;i++) /* Pour chacune des questions ... */
	{
	question=q.q[i];
	rang=cherche_nom_etat(question.nom,l);
	if (rang<0)          /*... si le nom est correct ... */
		{
		printf("\nEtat initial : %s",question.nom);
		printf("  ATTENTION, nom inconnu ");
		OK=0;
		}

										
	if (OK==0) goto question_suiv;
	etat_courant=rang;					/* ... on cre un tat initial ... */
		a=l.l[rang];
										/* ... et effectue la transition */	
		b.code=transition(a.code,M,seuil,logique);
		/* affiche_etat(a);enonce_code(b.code,l);*/
		printf("\n%s  => ",a.nom);
		enonce_etat(b,l);
	
	question_suiv:;
	}
}

/*-------------------------------------------------------------------RESISTANCE */
float resistance(float conductance)
/* La matrice de transition stocke des "conductances". On a besoin d'une fonction inverse
pour en dduire les seuils d'nergie correspondant. Noter que le rsultat DOIT tre un nombre entier
si l'on veut assurer, au moins dans le cas d'une logique parfaite (10), le cout nergtique nul */
{
float r;
 /*r=max_trans+1-conductance; */

r=floor(max_trans/conductance);
return r;
}
/*-------------------------------------------------------------------REVE */
void reve(struct liste_etats l,struct matrice M)
{
int n_trans;
int rang;
float seuil;

rang=alea(0,l.n_etats);
n_trans=alea(10,50);

monologue(l,M,rang,n_trans,seuil,0);

}
/*------------------------------------------------------------------- RIGID */
int	rigid(int ligne,int rigid_max,int type) /* Fonction donnant une rigidit croissante de 0  rigid_max 
										selon la ligne de la matrice de transition 
										et selon le type choisi */
{int ir;float r;

if (type==0) return rigid_max;  /* Constante */
				
if (rigid_max==0) return rigid_max ; /* SI la rigidit max est nulle, pas la peine de chercher
										 faire une variation, linaire ou pas ! */

					/* Logistique */
r=ligne;
if(r<=l_code/2) r=r*r*2*rigid_max/(l_code*l_code); else r=rigid_max*(1-(r-l_code)*(r-l_code)*2/(l_code*l_code));
ir=r;
/* printf("\n         rigidit ligne %i = %i",ligne,ir);*/
return ir;


				/* Linaire */
r=ligne;
r=r/l_code;
r=r*rigid_max;
ir=r;
/*printf("\n         rigidit ligne %i = %i",ligne,ir);*/
return ir;
}

/*-------------------------------------------------------------------STABILISATION */
void stabilisation(int rang, struct liste_etats *l,struct matrice *M,int rigid_max,int type_rigid,int global)
							/* Stabilise les transitions issues du rang-ime tat
							en "tassant" ses bits  1 vers les derniers.
							N'a videmment d'intrt que si la rigidit est fonction
							croissante de la ligne de la matrice */
{
struct code 		code;
int 				essai;
float 				essai_max;
int 				i;
int 				j,j0;
struct liste_etats 	lt;
int 				OK;
int					rang2;
float 				x;


x=l_code;x=x/2;
essai_max=pow(2,x); /* exp(x*log(2)) */
essai=0;
essai_max=10;
lt=*l;


nouv_essai:
if (essai<essai_max)
	{
			/* Cration d'un nouveau code juste un peu plus " droite" que l'ancien*/
	
	code=lt.l[rang].code;
	
	for (i=0;i<l_code;i++) /* Recherche du premier bit  1 */
		{
		if (code.code[i]==1) {j0=i+1; goto bit_0;}
		}
		
	bit_0:				/* Recherche du premier bit suivant  zro */
	for (j=j0;j<l_code;j++)
		{
		if (code.code[j]==0) goto tasse;
		}
	printf("\n La stabilit ne peur tre augmente pour l'tat %s",lt.l[rang].nom);
	return;
	
	
	tasse:
	printf("\n ancien code  ");affiche_code(code);
	code.code[i]=0;code.code[j]=1;
	printf("\n nouveau code ");affiche_code(code);

	/* On vrifie qu'il n'existe pas dj */
	rang2=doublon_code(code,lt);
	if (rang2>=0)    /* S'il existe dj, on essai de dcaler le bit  1 un peu plus  droite */
		{
		essai=essai+1;
		j0=j;
		goto nouv_essai;
		}
	

	/* Le code n'est pas un doublon : on tente la modification */

	modif_code(rang,code,&*l,&*M,rigid_max,type_rigid,global,logique, &OK);

	if (OK!=1) /* Si elle n'est pas possible, on essaie de dcaler le bit  1 un peu plus  droite  */
		{
		essai=essai+1;
		j0=j;
		goto nouv_essai;
		}
	GRAPHES(*l,*M);	
	}
else 
	{
	printf("\n Meilleure stabilisation impossible pour l'tat %s de rang %i ",lt.l[rang].nom,rang);
	}	

}						

/*------------------------------------------------------------------- SUPPRIME_ETAT */
struct liste_etats supprime_etat(struct liste_etats l)
{struct liste_etats lt;int rang;char nom[l_nom];
/* Choix de l'tat  supprimer */ 

lt=l;
printf("\nEtat  supprimer ?: ");scanf("%s",&nom);

/* Recherche si cet tat existe dj */

rang=cherche_nom_etat(nom,l);
if (rang<0) 
	{
	/* L'tat n'est pas nonable. On abandonne  */
	printf("\nDsol, je ne connait pas cet tat.");
	return lt;
	}
	
 /* L'tat  supprimer est bien nonable.
    On met le dernier tat  la place de celui  supprimer */

lt.n_etats=l.n_etats-1;
strcpy(lt.l[rang].nom,l.l[lt.n_etats].nom);
lt.l[rang].code=l.l[lt.n_etats].code;

printf("\n   Suppression faite");
nouv_etat=1;metrique=0;

return lt;

}


/*------------------------------------------------------------------- TOUTES_TRANSITIONS */
void toutes_transitions(struct liste_etats l, struct matrice M)
									/* Monologue d'affichage de toutes les premires transitions 
									 partir de tous les tats nonables */
{int i,rang;float d;
struct code c;
etat_courant=0;

 
for (i=0;i<l.n_etats;i++)
	{
	c=transition(l.l[i].code,M,seuil,logique);
	d=distance_min(c,l,&rang,type_dist);
	printf("\n %s  =>  %s", l.l[i].nom,l.l[rang].nom);
	etat_courant=rang;
	}
}

/*------------------------------------------------------------------- TRAITE_RECOMMS_E */
struct matrice traite_recomms_e(struct liste_recomms_e r_e,struct matrice M,int n_traite,int rigidite,int type_rigid,int *OK)
{int i,k,tout_OK,modif_OK;struct matrice Mt;
/* Traite les recommandations, en modifiant la matrice de transition 
A noter que l'on peut traiter la liste de recommandations plusieurs fois (n_traite)
*/

if (r_e.n_recomms>0)
	{
	Mt=M; /* On travaille sur une copie de la matrice de transition */

	tout_OK=1; /* A priori on suppose que a va marcher... */

	for (k=0;k<n_traite;k++)
		{
		if (r_e.n_recomms==1) printf("\n Traitement de %i recommandation",r_e.n_recomms);
		if (r_e.n_recomms>1) printf("\n Traitement de %i recommandations",r_e.n_recomms);

		for (i=0;i<r_e.n_recomms;i++)
			{
			Mt=modif_trans(M,r_e.r[i].a,r_e.r[i].b,r_e.r[i].avis,rigidite,type_rigid,&modif_OK);
			if (modif_OK==0) tout_OK=0; /*... mais c'est parfois impossible */ 
			}
		}
		if (tout_OK==1) printf("\n  Modification de la matrice de transition faite ");
		*OK=tout_OK;
		return Mt;	
	}
else
	{
	*OK=1;
	return M;
	}

}

/*------------------------------------------------------------------ TRANSITION */
struct code	transition(struct code code1,struct matrice M,float seuil,int logique)
{
float 		activ;
struct code c;
float		coeff_logique;
float		decharge,decharge_max,decharge_min;
float		energ;
float		flux;
int 		i,j;
int		 	method;
int			n_actifs;
int			OK;
float		seuil0;
float		seuil_energ;
float		stock;


/* Pour chaque nud i (lment de rang i du code final), on regarde la colonne i (les j nuds amonts).
   On la compare lment par lment au code initial.
Mthode 1
	S'il y a effectivement un lien (M.M[j][i]>=1) et si le nud est actif (code1.code[j]=='1')
	alors le noeud i doit tre activ (c.code[i]='1).
Mthode 2
	- on compte les nuds actifs n_actifs.
	- l'nergie disponible est rpartie uniformment sur chaque nud actif (stock_energ/n_actifs)
		par unit discrtes (quantums)
	- pour un nud donn i, pour chaque lien entrant "actif" j-i (issu d'un nud actif j) :
		- on regarde si l'nergie du nud est suprieure ou gale  celle ncessaire indique par le lien
		- si oui, on accumule sur i de l'nergie et on dcrmente plus ou 
		moins le stock, selon le niveau de logique.
		- si l'nergie accumule est suprieure ou gale au seuil, on active le nud i.
		
	A chaque pas de temps, le stock d'nergie augmente d'une unit de flux. Chaque transition utilise
	de l'nergie .
	
*/

code_courant=code1;

 /*printf("\n\n stock_energ avant transition %f et flux %f",stock_energ,flux_energ);*/
/* printf("\n"); affiche_code(code1); */

coeff_logique=logique/10;
method=2; 

flux=flux_energ;
stock=stock_energ+flux; /* Incrmentation du stock d'nergie  chaque pas de temps */

/*printf("\n(transition) stock %f flux %f  seuil %f logique %i",stock,flux,seuil,logique);*/



if (method==1) 
	{
	for (i=0;i<l_code;i++) /* Ici, si un nud a un nud amont actif, on l'active */
		{
		for (j=0;j<l_code;j++)
			{
			if ((M.M[j][i]>=1) && (code1.code[j]==1))
				{c.code[i]=1; goto autre_noeud1;};
			}
		c.code[i]=0;
		autre_noeud1:;	
		}

	}

if (method==2)
	{
	/* Seuil initial de dclenchement d'activation */

	seuil0=coeff_logique*seuil; /* Plus la logique est forte, plus le seuil est lev */
	/*printf("\n logique %i, seuil %f, seuil0 %f",logique,seuil,seuil0);*/

	OK=0;
	methode2:

	/* Calcul du nombre de nuds actifs */
	n_actifs=0;
	for (j=0;j<l_code;j++) 
		{
		if (code1.code[j]==1) n_actifs=n_actifs+1;
		};

 	/* printf("\n%i nuds actifs",n_actifs);*/

	repart_energ:

	/* Rpartition uniforme de l'nergie sur les nuds actifs */
	energ=stock/n_actifs; 

 	/*printf("\nenerg %f",energ);*/

	/* Pour chaque nud, on regarde les liens entrants */
	for (i=0;i<l_code;i++) /* Pour chaque nud ... */
		{
		activ=0;
		for (j=0;j<l_code;j++)  /* ... boucle sur les nuds amonts */
			{
			if (M.M[j][i]>=1)
		
				{
				seuil_energ=resistance(M.M[j][i]);
	
				if (code1.code[j]==1 && energ>=seuil_energ)
					{
					/* Si le lien existe, si le nud amont est actif et si l'nergie est suffisante 
					c'est--dire au moins gale  celle strictement ncessaire pour "passer" le lien 
					on accumule l'activation sur le nud tudi */
				
					activ=activ+energ-seuil_energ; /* Ici la valeur du lien est vue comme
																une "perte en ligne" */
				
					/*activ=activ+energ;*/ /* Ici la valeur du lien est juste vue comme un seuil */
			
			  	 	/* printf("\n%i %i activ = %f delta activ = %i seuil0 = %f",i,j,activ,max_trans+1-M.M[j][i], seuil0); */
				
			
					/* Ds que l'activation totale est suffisante, c'est OK, on active le nud */
					/* et on dcrmente le stock d'nergie */
					if (activ>=seuil0) 
						{
						c.code[i]=1;
						OK=1;
					
						decharge_min=activ;/* Ici, on ne dcharge que le nud concern */
						decharge_max=energ*n_actifs;/* Ici on dcharge tous les nuds (comportement systolique) */
						
						
						/* En fait, on module suivant le niveau de logique 
						ATTENTION : en logique parfaite (10), le stock d'nergie doit tre le mme
						avant et aprs la transition    */
						
						decharge=decharge_min+logique*(decharge_max-decharge_min)/10; 
					
						stock=stock-decharge;
						goto autre_noeud2;
						}
					}
				}
			}
		c.code[i]=0;
		autre_noeud2:;
		}

	/* Il faut au moins une activation. On accumule l'nergie ncessaire */
	if (OK==0) {stock=stock+flux_energ; goto repart_energ;};
	}


while (stock<0) {stock=stock+flux;};  /* Recharge, pour faire au moins une transition */	

stock_energ=stock; /* Mise  jour de la variable globale "stock d'nergie" */																	

/* printf("\n stock_energ aprs transition %f",stock_energ);*/

code_courant=c;	
return c;

}

/*------------------------------------------------------------------- TRANSITIONS_ENERG */
void transitions_energ(struct liste_etats l, struct matrice M)
/* Pour un tat initial donn, affiche toutes les transitions possibles selon
le niveau d'nergie */
{
struct code code2;
char nom[l_nom];
int rang;
float s0,s;


printf("\nNom de l'tat initial ?: ");scanf("%s",&nom); /* Saisie de l'tat initial, par son nom */

/* Recherche de l'tat initial. On vrifie qu'il existe bien dans la liste des tats nonables  */

rang=cherche_nom_etat(nom,l);

if (rang<0) 
	{printf("\nEtat non trouv "); return;}

s0=stock_energ;
s=s0;

while (stock_energ<=D.infini)
	{
printf("\n nergie courante/nergie max = %f/%f",stock_energ,D.infini);
	code2=transition(l.l[rang].code,M,seuil,logique); /* ... calcul du nouveau code ... */
	enonce_code(code2,l); /*... nonciation, plus ou moins certaine */
	s=s+flux_energ;
	stock_energ=s;
	}
	
stock_energ=s0;
}
/*------------------------------------------------------------------- ZZZ */
void ZZZ() /* Rserve de code source */
{
/**
/* ------------- affichage d'un texte dans un rectangle ------------------- */
	View(Out 2);
	Rectangle(Out K,Out X,Out Y,Out L,Out H,2)
		For K:InRange(K,0,l_code-1)
		Assign X=pos_x[K] Y=pos_y[K] L=10 H=10 If X>0 && Y>0;
	RectangleColor(K,Out C,2) 	Assign C= (code_courant.code[K]==1) ? Red : Grey;
	RectangleFrameColor(K,Out C,2) 	For C:RectangleColor(K,C,2);
	SmallText(Out 1,Out 10,Out 20,Out String,Out S,Out Left,2) Assign
	S="Cogito ergo sum";
**/
/*---------------------------------------------------------------------- */
/**   /* Etat courant, prsentation matricielle */
	View(Out 7); 
	MatrixTitle(Out S,7)    Assign S="Cogito ergo sum";
    Matrix(Out 40,Out 40,Out 4,Out l_code/4,7);
  	MatrixItemBackColor(I,J,Out C,7)  Assign C=(code_courant.code[5*I+J]==0) ? Grey : Red ;

   
**/

/* =1 si la liste des codes est affiche graphiquement (matrice) */


/* -------------------- affichage matrice liste des codes -------------- */
/**
	View(Out 2);
    Matrix(Out 40,Out 60,Out nmax_etats,Out l_code,2);
    MatrixItem(I,J,Out Int,Out L,2)           Assign L=l.l[I].code.code[J];
    MatrixItemColor(I,J,Out Red,2)            If l.l[I].code.code[J]==1;
    MatrixItemBackColor(I,J,Out LightGrey,2)  If l.l[I].code.code[J]==0;
    MatrixItemFace(I,J,Out Bold,2)            If l.l[I].code.code[J]==1;
   MatrixTitle(Out S,2)    Assign S="Codes des tats nonables";
**/



/**
  	Graph(Out 5); /* Graphe de la matrice de transition */
	Directed(1);/* Graphe orient */
	
	Node(Out N,5) For N:InRange(N,0,2*l_code-1); /* Gnre les ID des nuds, comme numros squentiels */

	NodeColor(N,Out Red,5)  If (N<l_code && l.l[etat_courant].code.code[N]==1); /* Couleur du nud activ */
	NodeColor(N,Out Red,5)  If (N>=l_code && l.l[etat_courant].code.code[N-l_code]==1); /* Couleur du nud activ */
	
	NodeName (N,Out String,Out S,5) Assign S=nom_bit.c[N].c; /* Met son nom dans chaque nud */
	
	
	NodePos(N,Out X,Out Y,5) Assign X=10 Y=10+20*N If N<l_code ;
	NodePos(N,Out X,Out Y,5) Assign X=150 Y=10+20*(N-l_code) If N>=l_code ;
	
	
	Arc(X,Y,5) If (X<l_code && Y>=l_code && M.M[X][Y-l_code]>0) ;
	 /* Epaisseur des arcs en fonction de leur valeur */
	/*ArcThickness(X,Y,Out S,5) Assign S=(1-(M.M[X][Y-l_code]-max_trans)^2/max_trans^2) If (X<l_code && Y>=l_code && M.M[X][Y-l_code]>0) ; */
	
	/*ArcLabel(X,Y,Out Int,Out L,5) Assign L=M.M[X][Y-l_code] If (X<l_code && Y>=l_code && M.M[X][Y-l_code]>0) ;*/
	
	ArcColor(X,Y,Out C,5) Assign C=1+15*M.M[X][Y]/(max_trans); /* Couleur des arcs en fonction de leur valeur */
									
**/

}